/* A Bison parser, made by GNU Bison 1.875d.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     MERGE_SPLITTED = 258,
     ASAP = 259,
     PRIORITY = 260,
     par_USE_HIOA_AUTOMATA = 261,
     par_CREATION_GRAPH_OUTPUT = 262,
     par_TIME_POST_LAMBDA = 263,
     par_TIME_POST_CONE_ITER = 264,
     par_TIME_POST_ITER = 265,
     par_ELAPSE_TIME = 266,
     par_BOUND_BOX_BITSIZE = 267,
     par_CONSTRAINT_BITSIZE = 268,
     par_REACH_STOP_USE_BITSIZE = 269,
     par_MEMORY_MODE = 270,
     par_CHEAP_CONTAIN_RETURN_OTHERS = 271,
     par_USE_CONVEX_HULL = 272,
     par_USE_CONSTRAINT_HULL = 273,
     par_REACH_STOP_AT_FORB = 274,
     par_REACH_ONLY_EXPLORE = 275,
     par_REACH_USE_BBOX = 276,
     par_REACH_MAX_ITER = 277,
     par_REACH_USE_BBOX_ITER = 278,
     par_REACH_STOP_USE_CONVEX_HULL_ITER = 279,
     par_REACH_STOP_USE_CONVEX_HULL_SETTLE = 280,
     par_REACH_CONSTRAINT_LIMIT = 281,
     par_LIMIT_CONSTRAINTS_METHOD = 282,
     par_TP_CONSTRAINT_LIMIT = 283,
     par_REACH_CONSTRAINT_TRIGGER = 284,
     par_REACH_BITSIZE_TRIGGER = 285,
     par_SEARCH_METHOD = 286,
     par_SNAPSHOT_INTERVAL = 287,
     par_USE_CONVEX_HULL_FOR_PRIMING = 288,
     par_PRIME_R_WITH_REACH = 289,
     par_SHOW_BAD_STATES = 290,
     par_SIM_SIMPLIFY_R = 291,
     par_PRIME_R_WITH_DISCRETE_REACH = 292,
     par_MINIM_USE_CONVEX_HULL_FOR_PRIMING = 293,
     par_MINIM_PRIME_R_WITH_REACH = 294,
     COMPOSE = 295,
     par_COMPOSE_WITH_REACH_MIN = 296,
     par_COMPOSE_USE_CONVEX_HULL_FOR_REACH = 297,
     par_REFINE_DERIVATIVE_METHOD = 298,
     par_REFINE_PRIORITIZE_REACH_SPLIT = 299,
     par_REFINE_SMALLEST_FIRST = 300,
     par_REFINE_USE_FP = 301,
     par_REFINE_DERIV_MINANGLE = 302,
     par_REFINE_PRIORITIZE_ANGLE = 303,
     par_REFINE_CHECK_TIME_RELEVANCE = 304,
     par_REFINE_CHECK_TIME_RELEVANCE_DURING = 305,
     par_REFINE_CHECK_TIME_RELEVANCE_FINAL = 306,
     par_REFINE_CHECK_TRANS_DIMS = 307,
     par_REFINE_PARTITION_INSIDE = 308,
     par_REACH_FB_REFINE_METHOD = 309,
     par_REFINE_INTERSECT_METHOD = 310,
     par_REFINE_LOCATION_PLANE = 311,
     SET_DHR_VARS = 312,
     par_DHR_THRESHOLD = 313,
     IS_REACHABLE_DHR = 314,
     par_REFINE_MAX_CHECKS = 315,
     PROJECT_TO = 316,
     DIFFERENCE_ASSIGN = 317,
     RENAME = 318,
     IS_REACHABLE = 319,
     IS_REACHABLE_FB = 320,
     INVARIANT_ASSIGN = 321,
     REVERSE = 322,
     SAVE_FP_SURFACE = 323,
     REACH_FORWARD_ITER = 324,
     UNLOCK_SURFACE_LOCS = 325,
     UNLOCK_LOCS = 326,
     GET_INVARIANTS = 327,
     PRINT_GRAPH = 328,
     PROJECT_TO_FIRST = 329,
     INVERSE = 330,
     CONTAINS = 331,
     REFINE_CONSTRAINTS = 332,
     ADD_LABEL = 333,
     WHO = 334,
     SAVE_FP_INVARS = 335,
     INITIAL_STATES = 336,
     REFINE_LOCS = 337,
     REFINE_LOC_DERIV = 338,
     GET_SIM = 339,
     IS_EMPTY = 340,
     INTERSECTION_ASSIGN = 341,
     LOC_INTERSECTION = 342,
     LOC_UNION = 343,
     REMOVE = 344,
     STRING_TEXT = 345,
     ECHO = 346,
     GET_PARAMETERS = 347,
     IS_SIM = 348,
     IS_BISIM = 349,
     AGSIM = 350,
     AGCSIM = 351,
     PRINT = 352,
     SAVE_CON_FP = 353,
     SAVE_GEN_FP = 354,
     REACH = 355,
     REACH_STOP = 356,
     DEFNE = 357,
     AUTOMATON = 358,
     INTERNAL_VAR = 359,
     EXTERNAL_VAR = 360,
     PARAMETER = 361,
     SYNCLABS = 362,
     INITIALLY = 363,
     LOC = 364,
     WHILE = 365,
     WAIT = 366,
     WHEN = 367,
     DO = 368,
     SYNC = 369,
     GOTO = 370,
     END = 371,
     TRUE = 372,
     FALSE = 373,
     ASSIGN = 374,
     INT = 375,
     IDENT = 376,
     STARIDENT = 377,
     EQ = 378,
     LE = 379,
     GE = 380,
     PRIM = 381
   };
#endif
#define MERGE_SPLITTED 258
#define ASAP 259
#define PRIORITY 260
#define par_USE_HIOA_AUTOMATA 261
#define par_CREATION_GRAPH_OUTPUT 262
#define par_TIME_POST_LAMBDA 263
#define par_TIME_POST_CONE_ITER 264
#define par_TIME_POST_ITER 265
#define par_ELAPSE_TIME 266
#define par_BOUND_BOX_BITSIZE 267
#define par_CONSTRAINT_BITSIZE 268
#define par_REACH_STOP_USE_BITSIZE 269
#define par_MEMORY_MODE 270
#define par_CHEAP_CONTAIN_RETURN_OTHERS 271
#define par_USE_CONVEX_HULL 272
#define par_USE_CONSTRAINT_HULL 273
#define par_REACH_STOP_AT_FORB 274
#define par_REACH_ONLY_EXPLORE 275
#define par_REACH_USE_BBOX 276
#define par_REACH_MAX_ITER 277
#define par_REACH_USE_BBOX_ITER 278
#define par_REACH_STOP_USE_CONVEX_HULL_ITER 279
#define par_REACH_STOP_USE_CONVEX_HULL_SETTLE 280
#define par_REACH_CONSTRAINT_LIMIT 281
#define par_LIMIT_CONSTRAINTS_METHOD 282
#define par_TP_CONSTRAINT_LIMIT 283
#define par_REACH_CONSTRAINT_TRIGGER 284
#define par_REACH_BITSIZE_TRIGGER 285
#define par_SEARCH_METHOD 286
#define par_SNAPSHOT_INTERVAL 287
#define par_USE_CONVEX_HULL_FOR_PRIMING 288
#define par_PRIME_R_WITH_REACH 289
#define par_SHOW_BAD_STATES 290
#define par_SIM_SIMPLIFY_R 291
#define par_PRIME_R_WITH_DISCRETE_REACH 292
#define par_MINIM_USE_CONVEX_HULL_FOR_PRIMING 293
#define par_MINIM_PRIME_R_WITH_REACH 294
#define COMPOSE 295
#define par_COMPOSE_WITH_REACH_MIN 296
#define par_COMPOSE_USE_CONVEX_HULL_FOR_REACH 297
#define par_REFINE_DERIVATIVE_METHOD 298
#define par_REFINE_PRIORITIZE_REACH_SPLIT 299
#define par_REFINE_SMALLEST_FIRST 300
#define par_REFINE_USE_FP 301
#define par_REFINE_DERIV_MINANGLE 302
#define par_REFINE_PRIORITIZE_ANGLE 303
#define par_REFINE_CHECK_TIME_RELEVANCE 304
#define par_REFINE_CHECK_TIME_RELEVANCE_DURING 305
#define par_REFINE_CHECK_TIME_RELEVANCE_FINAL 306
#define par_REFINE_CHECK_TRANS_DIMS 307
#define par_REFINE_PARTITION_INSIDE 308
#define par_REACH_FB_REFINE_METHOD 309
#define par_REFINE_INTERSECT_METHOD 310
#define par_REFINE_LOCATION_PLANE 311
#define SET_DHR_VARS 312
#define par_DHR_THRESHOLD 313
#define IS_REACHABLE_DHR 314
#define par_REFINE_MAX_CHECKS 315
#define PROJECT_TO 316
#define DIFFERENCE_ASSIGN 317
#define RENAME 318
#define IS_REACHABLE 319
#define IS_REACHABLE_FB 320
#define INVARIANT_ASSIGN 321
#define REVERSE 322
#define SAVE_FP_SURFACE 323
#define REACH_FORWARD_ITER 324
#define UNLOCK_SURFACE_LOCS 325
#define UNLOCK_LOCS 326
#define GET_INVARIANTS 327
#define PRINT_GRAPH 328
#define PROJECT_TO_FIRST 329
#define INVERSE 330
#define CONTAINS 331
#define REFINE_CONSTRAINTS 332
#define ADD_LABEL 333
#define WHO 334
#define SAVE_FP_INVARS 335
#define INITIAL_STATES 336
#define REFINE_LOCS 337
#define REFINE_LOC_DERIV 338
#define GET_SIM 339
#define IS_EMPTY 340
#define INTERSECTION_ASSIGN 341
#define LOC_INTERSECTION 342
#define LOC_UNION 343
#define REMOVE 344
#define STRING_TEXT 345
#define ECHO 346
#define GET_PARAMETERS 347
#define IS_SIM 348
#define IS_BISIM 349
#define AGSIM 350
#define AGCSIM 351
#define PRINT 352
#define SAVE_CON_FP 353
#define SAVE_GEN_FP 354
#define REACH 355
#define REACH_STOP 356
#define DEFNE 357
#define AUTOMATON 358
#define INTERNAL_VAR 359
#define EXTERNAL_VAR 360
#define PARAMETER 361
#define SYNCLABS 362
#define INITIALLY 363
#define LOC 364
#define WHILE 365
#define WAIT 366
#define WHEN 367
#define DO 368
#define SYNC 369
#define GOTO 370
#define END 371
#define TRUE 372
#define FALSE 373
#define ASSIGN 374
#define INT 375
#define IDENT 376
#define STARIDENT 377
#define EQ 378
#define LE 379
#define GE 380
#define PRIM 381




/* Copy the first part of user declarations.  */
#line 2 "parser.y"

	#include <stdio.h>
	#include <stdlib.h>
	#include <string.h>
	#include <clock_val_set.h>
	#include <automaton.h>
	
	#define YY_ALWAYS_INTERACTIVE 1
	#define YYDEBUG 1
	
	#ifdef CPLUSPLUS
	extern int yylex();
	#endif

  extern unsigned int line_number;
	void yyerror(const char *msg)
	{		
      printf("Parse error in line %d: ", line_number);
      printf("%s\n", msg);
	}
  
	void yyerror(const string s)
	{
      yyerror(s.c_str());
	}
  
  string str;

	Rational_Linear_Expression * plinexp;
	Constraint * pcon;
	clock_val_set * pcvs, *pcvs2;
  clock_val_set mycvs;
  automaton *paut;
  symb_states_type *psymb_state;
  clock_ref_set * pcrs;
  vector<string> mystringvec;
  vector<automaton> aut_vec;
  transition_ref trans_ref;

	map <string, unsigned int> varmap;
	map <string, Rational_Linear_Expression> linexmap;
  map <string, pair <symb_states_type, automaton*> > sstatesmap;
  map <string, pair <state_relation, pair <automaton*, automaton*> > > sstate_relationmap;  
	map <string, automaton*> pautmap;

//	automaton_vec aut_vec;  // automaton-vector
  symb_states_type sstates;
  unsigned int dim=1;


  string outfilename="out";
  ofstream file_out;


//  automaton myaut(0);
  clock_val_set g,gg,gc;
  time_elapse_poly univ_tp(dim),tp(dim),tp2(dim);
  clock_ref_set r,rx;
  string current_loc_name;
  
  refinement_method ref_meth;
  


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 66 "parser.y"
typedef union YYSTYPE {
 char * mystring;
 Rational_Linear_Expression  *linexp;
 Constraint *	con;
 Constraint_List * con_list;
 clock_val_set * cvs;
 automaton *aut;
 bool mybool;
 symb_states_type *symb_state;
 clock_ref_set *crs;
 ConstraintRatPair *pconstraint_rat_pair;
 list <ConstraintRatPair> *pconstraint_rat_pair_list;
 list<string> *pident_list;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 407 "parser.tab.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 419 "parser.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   define YYSTACK_ALLOC alloca
#  endif
# else
#  if defined (alloca) || defined (_ALLOCA_H)
#   define YYSTACK_ALLOC alloca
#  else
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  130
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   769

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  147
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  40
/* YYNRULES -- Number of rules. */
#define YYNRULES  199
/* YYNRULES -- Number of states. */
#define YYNSTATES  678

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   381

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   134,     2,     2,     2,     2,   124,     2,
     135,   136,   132,   130,   141,   131,   140,   133,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   146,   138,
     125,   139,   126,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   142,     2,   143,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   144,   123,   145,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   127,   128,
     129,   137
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     5,     8,    10,    12,    14,    18,    21,
      26,    31,    41,    49,    57,    65,    66,    76,    77,    86,
      87,    96,   104,   109,   114,   121,   128,   135,   143,   151,
     159,   164,   174,   184,   194,   201,   209,   214,   222,   230,
     231,   246,   251,   259,   269,   276,   284,   292,   302,   312,
     322,   334,   342,   350,   362,   374,   379,   391,   399,   400,
     411,   418,   425,   433,   438,   439,   450,   452,   456,   460,
     464,   469,   474,   479,   484,   489,   494,   499,   504,   509,
     514,   519,   524,   529,   534,   539,   545,   550,   555,   560,
     565,   570,   575,   580,   585,   590,   595,   600,   605,   610,
     615,   620,   625,   630,   635,   641,   646,   651,   656,   661,
     666,   671,   676,   681,   686,   691,   696,   701,   706,   711,
     716,   721,   726,   731,   736,   741,   743,   745,   746,   752,
     756,   757,   760,   763,   766,   769,   772,   777,   782,   787,
     792,   797,   801,   803,   807,   809,   813,   815,   819,   821,
     828,   833,   838,   842,   846,   852,   856,   861,   864,   868,
     878,   881,   882,   894,   906,   914,   927,   940,   949,   953,
     955,   961,   969,   973,   977,   980,   984,   986,   990,   992,
     994,  1000,  1006,  1012,  1018,  1022,  1026,  1030,  1034,  1038,
    1040,  1042,  1044,  1047,  1049,  1053,  1057,  1061,  1065,  1068
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short int yyrhs[] =
{
     148,     0,    -1,   149,    -1,   149,   150,    -1,   150,    -1,
     159,    -1,   161,    -1,    91,    90,   138,    -1,    79,   138,
      -1,   121,   139,   121,   138,    -1,   121,   140,    97,   138,
      -1,   121,   140,    97,   135,    90,   141,   120,   136,   138,
      -1,   121,   140,    99,   135,    90,   136,   138,    -1,   121,
     140,    98,   135,    90,   136,   138,    -1,   121,   140,    98,
     142,    90,   143,   138,    -1,    -1,   121,   139,   121,   140,
     151,   144,   175,   145,   138,    -1,    -1,   121,   140,   152,
      89,   135,   157,   136,   138,    -1,    -1,   121,   140,   153,
      61,   135,   157,   136,   138,    -1,    92,   135,   121,   141,
     160,   136,   138,    -1,   121,   140,    88,   138,    -1,   121,
     140,    87,   138,    -1,   121,   139,   121,   140,    88,   138,
      -1,   121,   139,   121,   140,    87,   138,    -1,   121,   139,
     121,   140,     3,   138,    -1,   121,   140,    86,   135,   121,
     136,   138,    -1,   121,   140,    62,   135,   121,   136,   138,
      -1,   121,   140,    76,   135,   121,   136,   138,    -1,   121,
     140,    85,   138,    -1,   121,   140,    63,   135,   121,   141,
     121,   136,   138,    -1,   121,   139,    84,   135,   121,   141,
     121,   136,   138,    -1,   121,   139,   121,   140,    75,   135,
     121,   136,   138,    -1,   121,   139,   121,   140,    74,   138,
      -1,   121,   139,    40,   135,   173,   136,   138,    -1,   121,
     139,   158,   138,    -1,   121,   140,    80,   135,    90,   136,
     138,    -1,   121,   140,    68,   135,    90,   136,   138,    -1,
      -1,   121,   140,    73,   135,    90,   141,   154,   144,   157,
     145,   141,   121,   136,   138,    -1,   121,   140,    67,   138,
      -1,   121,   140,    78,   135,   121,   136,   138,    -1,   121,
     139,   121,   140,    69,   135,   120,   136,   138,    -1,   121,
     139,   121,   140,   100,   138,    -1,   121,   140,    81,   135,
     121,   136,   138,    -1,   121,   140,    66,   135,   121,   136,
     138,    -1,   121,   139,   121,   140,   100,   135,   121,   136,
     138,    -1,   121,   139,   121,   140,    64,   135,   121,   136,
     138,    -1,   121,   139,   121,   140,    65,   135,   121,   136,
     138,    -1,   121,   139,   121,   140,    59,   135,   121,   141,
     186,   136,   138,    -1,    93,   135,   121,   141,   121,   136,
     138,    -1,    94,   135,   121,   141,   121,   136,   138,    -1,
      95,   135,   121,   141,   121,   141,   121,   141,   121,   136,
     138,    -1,    96,   135,   121,   141,   121,   141,   121,   141,
     121,   136,   138,    -1,   121,   140,    83,   138,    -1,   121,
     140,    82,   135,   121,   141,   121,   141,   120,   136,   138,
      -1,   121,   140,    82,   135,   121,   136,   138,    -1,    -1,
     121,   140,    77,   155,   135,   180,   141,   121,   136,   138,
      -1,   121,   139,   121,   140,    81,   138,    -1,   121,   139,
     121,   140,    72,   138,    -1,   121,   140,    70,   135,   121,
     136,   138,    -1,   121,   140,    71,   138,    -1,    -1,   121,
     140,    57,   156,   135,   157,   138,   157,   136,   138,    -1,
     121,    -1,   157,   141,   121,    -1,   158,   124,   121,    -1,
     121,   124,   121,    -1,   121,   119,   186,   138,    -1,    58,
     139,   186,   138,    -1,    11,   139,   160,   138,    -1,    10,
     139,   120,   138,    -1,     9,   139,   120,   138,    -1,     8,
     139,   186,   138,    -1,    15,   139,   120,   138,    -1,     7,
     139,   160,   138,    -1,    16,   139,   160,   138,    -1,    17,
     139,   160,   138,    -1,    18,   139,   160,   138,    -1,    19,
     139,   160,   138,    -1,    20,   139,   160,   138,    -1,    21,
     139,   160,   138,    -1,    22,   139,   120,   138,    -1,    22,
     139,   131,   120,   138,    -1,    23,   139,   120,   138,    -1,
      24,   139,   120,   138,    -1,    14,   139,   120,   138,    -1,
      25,   139,   160,   138,    -1,    12,   139,   120,   138,    -1,
      13,   139,   120,   138,    -1,    27,   139,   160,   138,    -1,
      43,   139,   120,   138,    -1,    44,   139,   160,   138,    -1,
      45,   139,   160,   138,    -1,    46,   139,   160,   138,    -1,
      47,   139,   186,   138,    -1,    48,   139,   160,   138,    -1,
      26,   139,   120,   138,    -1,    28,   139,   120,   138,    -1,
      29,   139,   120,   138,    -1,    30,   139,   120,   138,    -1,
      31,   139,   120,   138,    -1,    31,   139,   131,   120,   138,
      -1,    32,   139,   120,   138,    -1,    49,   139,   160,   138,
      -1,    50,   139,   160,   138,    -1,    51,   139,   160,   138,
      -1,    52,   139,   160,   138,    -1,    53,   139,   160,   138,
      -1,    54,   139,   120,   138,    -1,    55,   139,   120,   138,
      -1,    56,   139,   120,   138,    -1,    60,   139,   120,   138,
      -1,    33,   139,   160,   138,    -1,    34,   139,   160,   138,
      -1,    37,   139,   160,   138,    -1,    35,   139,   160,   138,
      -1,    36,   139,   160,   138,    -1,    38,   139,   160,   138,
      -1,    39,   139,   160,   138,    -1,    41,   139,   160,   138,
      -1,    42,   139,   160,   138,    -1,     6,   139,   160,   138,
      -1,   117,    -1,   118,    -1,    -1,   103,   121,   162,   163,
     116,    -1,   164,   176,   174,    -1,    -1,   164,   165,    -1,
     164,   167,    -1,   164,   168,    -1,   164,   166,    -1,   164,
     169,    -1,     5,   146,   186,   138,    -1,   107,   146,   173,
     138,    -1,   104,   146,   170,   138,    -1,   105,   146,   171,
     138,    -1,   106,   146,   172,   138,    -1,   170,   141,   121,
      -1,   121,    -1,   171,   141,   121,    -1,   121,    -1,   172,
     141,   121,    -1,   121,    -1,   173,   141,   121,    -1,   121,
      -1,   173,   141,   121,   144,   173,   145,    -1,   121,   144,
     173,   145,    -1,   108,   146,   175,   138,    -1,   108,   175,
     138,    -1,   121,   124,   182,    -1,   175,   141,   121,   124,
     182,    -1,   176,   177,   178,    -1,   176,   177,   138,   178,
      -1,   177,   178,    -1,   177,   138,   178,    -1,   109,   121,
     146,   110,   182,   111,   144,   183,   145,    -1,   178,   179,
      -1,    -1,   112,   182,   114,   173,   113,   144,   182,   145,
     115,   121,   138,    -1,   112,   182,   113,   144,   182,   145,
     114,   173,   115,   121,   138,    -1,   112,   182,   114,   173,
     115,   121,   138,    -1,   112,   182,     4,   114,   173,   113,
     144,   182,   145,   115,   121,   138,    -1,   112,   182,     4,
     113,   144,   182,   145,   114,   173,   115,   121,   138,    -1,
     112,   182,     4,   114,   173,   115,   121,   138,    -1,   180,
     141,   181,    -1,   181,    -1,   135,   186,   141,   186,   136,
      -1,   135,   186,   141,   186,   141,   186,   136,    -1,   182,
     123,   182,    -1,   182,   124,   182,    -1,   134,   182,    -1,
     135,   182,   136,    -1,   184,    -1,   183,   124,   183,    -1,
     184,    -1,   185,    -1,   186,   128,   186,   128,   186,    -1,
     186,   125,   186,   128,   186,    -1,   186,   128,   186,   125,
     186,    -1,   186,   125,   186,   125,   186,    -1,   186,   125,
     186,    -1,   186,   126,   186,    -1,   186,   129,   186,    -1,
     186,   128,   186,    -1,   186,   127,   186,    -1,   117,    -1,
     118,    -1,   120,    -1,   121,   137,    -1,   121,    -1,   186,
     132,   186,    -1,   186,   133,   186,    -1,   186,   130,   186,
      -1,   186,   131,   186,    -1,   131,   186,    -1,   135,   186,
     136,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   236,   236,   239,   240,   244,   245,   249,   251,   285,
     304,   331,   374,   394,   414,   436,   436,   447,   446,   470,
     469,   501,   523,   530,   537,   547,   557,   567,   578,   589,
     603,   612,   624,   627,   631,   643,   663,   688,   700,   713,
     712,   739,   748,   757,   766,   775,   795,   815,   837,   862,
     887,   912,   926,   940,   942,   944,   946,   964,   968,   968,
     974,   983,   992,  1003,  1011,  1010,  1026,  1057,  1089,  1090,
    1139,  1140,  1142,  1143,  1144,  1146,  1147,  1150,  1151,  1152,
    1153,  1154,  1155,  1156,  1157,  1158,  1159,  1160,  1161,  1162,
    1163,  1164,  1165,  1166,  1167,  1168,  1169,  1170,  1171,  1172,
    1173,  1174,  1175,  1176,  1177,  1178,  1180,  1181,  1182,  1183,
    1184,  1185,  1186,  1187,  1188,  1191,  1192,  1193,  1194,  1195,
    1197,  1198,  1200,  1201,  1202,  1206,  1207,  1211,  1211,  1220,
    1223,  1225,  1226,  1227,  1228,  1229,  1233,  1240,  1256,  1260,
    1264,  1267,  1268,  1271,  1272,  1275,  1276,  1279,  1284,  1290,
    1299,  1314,  1317,  1321,  1334,  1349,  1350,  1351,  1352,  1356,
    1367,  1368,  1373,  1381,  1389,  1403,  1413,  1423,  1442,  1444,
    1449,  1455,  1478,  1480,  1489,  1490,  1491,  1500,  1503,  1506,
    1508,  1516,  1524,  1532,  1544,  1548,  1552,  1556,  1560,  1564,
    1566,  1573,  1577,  1591,  1615,  1624,  1630,  1632,  1634,  1639
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "MERGE_SPLITTED", "ASAP", "PRIORITY",
  "par_USE_HIOA_AUTOMATA", "par_CREATION_GRAPH_OUTPUT",
  "par_TIME_POST_LAMBDA", "par_TIME_POST_CONE_ITER", "par_TIME_POST_ITER",
  "par_ELAPSE_TIME", "par_BOUND_BOX_BITSIZE", "par_CONSTRAINT_BITSIZE",
  "par_REACH_STOP_USE_BITSIZE", "par_MEMORY_MODE",
  "par_CHEAP_CONTAIN_RETURN_OTHERS", "par_USE_CONVEX_HULL",
  "par_USE_CONSTRAINT_HULL", "par_REACH_STOP_AT_FORB",
  "par_REACH_ONLY_EXPLORE", "par_REACH_USE_BBOX", "par_REACH_MAX_ITER",
  "par_REACH_USE_BBOX_ITER", "par_REACH_STOP_USE_CONVEX_HULL_ITER",
  "par_REACH_STOP_USE_CONVEX_HULL_SETTLE", "par_REACH_CONSTRAINT_LIMIT",
  "par_LIMIT_CONSTRAINTS_METHOD", "par_TP_CONSTRAINT_LIMIT",
  "par_REACH_CONSTRAINT_TRIGGER", "par_REACH_BITSIZE_TRIGGER",
  "par_SEARCH_METHOD", "par_SNAPSHOT_INTERVAL",
  "par_USE_CONVEX_HULL_FOR_PRIMING", "par_PRIME_R_WITH_REACH",
  "par_SHOW_BAD_STATES", "par_SIM_SIMPLIFY_R",
  "par_PRIME_R_WITH_DISCRETE_REACH",
  "par_MINIM_USE_CONVEX_HULL_FOR_PRIMING", "par_MINIM_PRIME_R_WITH_REACH",
  "COMPOSE", "par_COMPOSE_WITH_REACH_MIN",
  "par_COMPOSE_USE_CONVEX_HULL_FOR_REACH", "par_REFINE_DERIVATIVE_METHOD",
  "par_REFINE_PRIORITIZE_REACH_SPLIT", "par_REFINE_SMALLEST_FIRST",
  "par_REFINE_USE_FP", "par_REFINE_DERIV_MINANGLE",
  "par_REFINE_PRIORITIZE_ANGLE", "par_REFINE_CHECK_TIME_RELEVANCE",
  "par_REFINE_CHECK_TIME_RELEVANCE_DURING",
  "par_REFINE_CHECK_TIME_RELEVANCE_FINAL", "par_REFINE_CHECK_TRANS_DIMS",
  "par_REFINE_PARTITION_INSIDE", "par_REACH_FB_REFINE_METHOD",
  "par_REFINE_INTERSECT_METHOD", "par_REFINE_LOCATION_PLANE",
  "SET_DHR_VARS", "par_DHR_THRESHOLD", "IS_REACHABLE_DHR",
  "par_REFINE_MAX_CHECKS", "PROJECT_TO", "DIFFERENCE_ASSIGN", "RENAME",
  "IS_REACHABLE", "IS_REACHABLE_FB", "INVARIANT_ASSIGN", "REVERSE",
  "SAVE_FP_SURFACE", "REACH_FORWARD_ITER", "UNLOCK_SURFACE_LOCS",
  "UNLOCK_LOCS", "GET_INVARIANTS", "PRINT_GRAPH", "PROJECT_TO_FIRST",
  "INVERSE", "CONTAINS", "REFINE_CONSTRAINTS", "ADD_LABEL", "WHO",
  "SAVE_FP_INVARS", "INITIAL_STATES", "REFINE_LOCS", "REFINE_LOC_DERIV",
  "GET_SIM", "IS_EMPTY", "INTERSECTION_ASSIGN", "LOC_INTERSECTION",
  "LOC_UNION", "REMOVE", "STRING_TEXT", "ECHO", "GET_PARAMETERS", "IS_SIM",
  "IS_BISIM", "AGSIM", "AGCSIM", "PRINT", "SAVE_CON_FP", "SAVE_GEN_FP",
  "REACH", "REACH_STOP", "DEFNE", "AUTOMATON", "INTERNAL_VAR",
  "EXTERNAL_VAR", "PARAMETER", "SYNCLABS", "INITIALLY", "LOC", "WHILE",
  "WAIT", "WHEN", "DO", "SYNC", "GOTO", "END", "TRUE", "FALSE", "ASSIGN",
  "INT", "IDENT", "STARIDENT", "'|'", "'&'", "'<'", "'>'", "EQ", "LE",
  "GE", "'+'", "'-'", "'*'", "'/'", "'!'", "'('", "')'", "PRIM", "';'",
  "'='", "'.'", "','", "'['", "']'", "'{'", "'}'", "':'", "$accept",
  "program", "commands", "command", "@1", "@2", "@3", "@4", "@5", "@6",
  "clock_ref_list", "composed_aut", "prelim", "bool_type", "automaton",
  "@7", "automaton_body", "declaration", "priority", "synclab",
  "internal_vars", "external_vars", "parameters", "ivar_list", "evar_list",
  "param_list", "ident_list", "initial", "state_list", "location_list",
  "location", "transition_list", "transition", "constraint_rat_pair_list",
  "constraint_rat_pair", "val_set", "constr_list", "constr_list_no_and",
  "constraint", "linearexpr", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   124,    38,    60,    62,   378,   379,   380,
      43,    45,    42,    47,    33,    40,    41,   381,    59,    61,
      46,    44,    91,    93,   123,   125,    58
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,   147,   148,   149,   149,   150,   150,   150,   150,   150,
     150,   150,   150,   150,   150,   151,   150,   152,   150,   153,
     150,   150,   150,   150,   150,   150,   150,   150,   150,   150,
     150,   150,   150,   150,   150,   150,   150,   150,   150,   154,
     150,   150,   150,   150,   150,   150,   150,   150,   150,   150,
     150,   150,   150,   150,   150,   150,   150,   150,   155,   150,
     150,   150,   150,   150,   156,   150,   157,   157,   158,   158,
     159,   159,   159,   159,   159,   159,   159,   159,   159,   159,
     159,   159,   159,   159,   159,   159,   159,   159,   159,   159,
     159,   159,   159,   159,   159,   159,   159,   159,   159,   159,
     159,   159,   159,   159,   159,   159,   159,   159,   159,   159,
     159,   159,   159,   159,   159,   159,   159,   159,   159,   159,
     159,   159,   159,   159,   159,   160,   160,   162,   161,   163,
     164,   164,   164,   164,   164,   164,   165,   166,   167,   168,
     169,   170,   170,   171,   171,   172,   172,   173,   173,   173,
     173,   174,   174,   175,   175,   176,   176,   176,   176,   177,
     178,   178,   179,   179,   179,   179,   179,   179,   180,   180,
     181,   181,   182,   182,   182,   182,   182,   183,   183,   184,
     184,   184,   184,   184,   185,   185,   185,   185,   185,   185,
     185,   186,   186,   186,   186,   186,   186,   186,   186,   186
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     2,     1,     1,     1,     3,     2,     4,
       4,     9,     7,     7,     7,     0,     9,     0,     8,     0,
       8,     7,     4,     4,     6,     6,     6,     7,     7,     7,
       4,     9,     9,     9,     6,     7,     4,     7,     7,     0,
      14,     4,     7,     9,     6,     7,     7,     9,     9,     9,
      11,     7,     7,    11,    11,     4,    11,     7,     0,    10,
       6,     6,     7,     4,     0,    10,     1,     3,     3,     3,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     5,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     5,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     1,     1,     0,     5,     3,
       0,     2,     2,     2,     2,     2,     4,     4,     4,     4,
       4,     3,     1,     3,     1,     3,     1,     3,     1,     6,
       4,     4,     3,     3,     5,     3,     4,     2,     3,     9,
       2,     0,    11,    11,     7,    12,    12,     8,     3,     1,
       5,     7,     3,     3,     2,     3,     1,     3,     1,     1,
       5,     5,     5,     5,     3,     3,     3,     3,     3,     1,
       1,     1,     2,     1,     3,     3,     3,     3,     2,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     2,     4,     5,     6,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     8,
       0,     0,     0,     0,     0,     0,   127,     0,     0,    17,
       1,     3,   125,   126,     0,     0,   191,   193,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     7,     0,     0,     0,     0,     0,   130,     0,
       0,     0,     0,     0,    64,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    58,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   124,
      77,   192,   198,     0,     0,     0,     0,     0,    75,    74,
      73,    72,    90,    91,    88,    76,    78,    79,    80,    81,
      82,    83,    84,     0,    86,    87,    89,    99,    92,   100,
     101,   102,   103,     0,   105,   115,   116,   118,   119,   117,
     120,   121,   122,   123,    93,    94,    95,    96,    97,    98,
     106,   107,   108,   109,   110,   111,   112,   113,    71,   114,
       0,     0,     0,     0,     0,     0,     0,    70,     0,     0,
       0,     9,    15,     0,    36,     0,     0,     0,     0,    41,
       0,     0,    63,     0,     0,     0,     0,     0,     0,     0,
      55,    30,     0,    23,    22,     0,    10,     0,     0,     0,
       0,     0,   199,   196,   197,   194,   195,    85,   104,     0,
       0,     0,     0,     0,   128,     0,     0,     0,     0,     0,
       0,   131,   134,   132,   133,   135,     0,   161,   148,     0,
       0,    69,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    68,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   129,   161,
     161,   157,     0,     0,     0,     0,    26,     0,     0,     0,
       0,    61,    34,     0,    60,    25,    24,     0,    44,     0,
      66,     0,     0,     0,     0,     0,     0,    39,     0,     0,
       0,   169,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    21,    51,    52,     0,     0,     0,
     142,     0,   144,     0,   146,     0,     0,     0,     0,     0,
       0,   161,   155,   158,     0,   160,     0,    35,   147,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    28,
       0,    46,    38,    62,     0,    29,     0,     0,    42,    37,
      45,    57,     0,    27,     0,    13,    14,    12,     0,     0,
       0,     0,   136,   138,     0,   139,     0,   140,     0,   137,
       0,     0,     0,   152,     0,   156,   189,   190,     0,     0,
       0,   176,   179,     0,   150,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    67,     0,     0,     0,     0,
     168,     0,     0,    18,    20,     0,     0,   141,   143,   145,
       0,   153,   151,     0,   174,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    32,     0,
      48,    49,    43,    33,    47,    16,     0,    31,     0,     0,
       0,     0,    11,     0,     0,     0,     0,   175,     0,     0,
       0,     0,   172,   173,   184,   185,   188,   187,   186,   149,
       0,    65,     0,   170,     0,    59,     0,    53,    54,     0,
     154,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      50,     0,     0,    56,     0,   178,     0,     0,     0,     0,
       0,     0,   183,   181,   182,   180,     0,   171,     0,   159,
       0,     0,     0,     0,     0,   164,     0,   177,     0,     0,
     167,     0,     0,    40,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   163,   162,   166,   165
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,    62,    63,    64,   374,   227,   228,   494,   315,   305,
     431,   203,    65,   134,    66,   198,   295,   296,   351,   352,
     353,   354,   355,   461,   463,   465,   359,   408,   470,   356,
     357,   411,   475,   440,   441,   530,   634,   531,   532,   533
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -610
static const short int yypact[] =
{
     254,  -131,  -115,   -95,   -39,   -27,    24,    32,    78,    80,
     109,   117,   155,   172,   174,   187,   205,   217,   265,   266,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   -13,    47,    10,    38,    52,   238,   305,
      88,   -21,   369,   254,  -610,  -610,  -610,    33,    33,    59,
     321,   322,    33,   323,   324,   325,   326,    33,    33,    33,
      33,    33,    33,  -111,   327,   328,    33,   329,    33,   330,
     331,   332,     1,   333,    33,    33,    33,    33,    33,    33,
      33,    33,    33,   334,    33,    33,    33,    59,    33,    33,
      33,    33,    33,    33,   335,   336,   337,    59,   338,  -610,
     263,   340,   341,   342,   343,   344,  -610,    59,   -22,   115,
    -610,  -610,  -610,  -610,   339,   345,  -610,   347,    59,    59,
      26,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   346,   362,   363,   364,   370,
     371,   372,   373,   374,   375,   365,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     197,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     221,   399,  -610,   318,   400,   401,   402,   403,  -610,   230,
     404,   405,    -4,  -113,  -610,   411,   412,   413,   414,   415,
     416,   417,   418,   419,  -610,   421,   426,   427,   428,   429,
     430,   431,   432,   433,   104,    18,   434,   317,   406,  -610,
    -610,  -610,  -610,   246,    59,    59,    59,    59,  -610,  -610,
    -610,  -610,  -610,  -610,  -610,  -610,  -610,  -610,  -610,  -610,
    -610,  -610,  -610,   435,  -610,  -610,  -610,  -610,  -610,  -610,
    -610,  -610,  -610,   436,  -610,  -610,  -610,  -610,  -610,  -610,
    -610,  -610,  -610,  -610,  -610,  -610,  -610,  -610,  -610,  -610,
    -610,  -610,  -610,  -610,  -610,  -610,  -610,  -610,  -610,  -610,
      33,   443,   444,   451,   454,   366,    -2,  -610,   455,   456,
     457,  -610,    74,   458,  -610,   445,   460,   461,   462,  -610,
     448,   463,  -610,   459,   464,   452,   465,   498,   468,   469,
    -610,  -610,   470,  -610,  -610,   502,  -610,   503,   504,   505,
     466,   467,  -610,   100,   100,  -610,  -610,  -610,  -610,   471,
     472,   473,   474,   475,  -610,   450,   453,   476,   477,   478,
     479,  -610,  -610,  -610,  -610,  -610,   216,   480,   481,  -110,
     485,  -610,   482,   484,   486,   492,   493,   491,   494,   495,
     496,   497,   499,   220,   487,  -610,   483,   500,   501,   507,
     508,   509,   506,   510,   513,   514,   515,   516,   -60,   517,
     518,   519,   490,   520,   483,   483,   511,   522,   523,   489,
     533,    59,   536,   537,   541,   455,   521,  -106,  -610,   525,
    -610,   368,   455,   526,   544,   545,  -610,   547,   548,   549,
     551,  -610,  -610,   552,  -610,  -610,  -610,   553,  -610,   554,
    -610,   102,   534,   555,   539,   540,   542,  -610,   543,    59,
     538,  -610,   546,   550,   556,   557,   561,   558,   563,   559,
     560,   562,     6,    34,  -610,  -610,  -610,   564,   565,   234,
    -610,   116,  -610,   233,  -610,   256,   257,   488,   566,   554,
     261,  -610,   368,   368,    87,  -610,    65,  -610,   567,   568,
     569,   571,   572,   573,   576,   577,    70,   483,   570,  -610,
     578,  -610,  -610,  -610,   574,  -610,   -48,   -47,  -610,  -610,
    -610,  -610,   575,  -610,   579,  -610,  -610,  -610,   581,   582,
     580,   596,  -610,  -610,   600,  -610,   601,  -610,   602,  -610,
      87,    87,   262,  -610,   603,   368,  -610,  -610,    87,    87,
       0,  -610,  -610,   190,  -610,   455,   587,    59,   588,   589,
     590,   591,   592,   593,    48,  -610,   594,   483,    59,   597,
    -610,   583,   598,  -610,  -610,   599,   604,  -610,  -610,  -610,
     -32,   264,  -610,   610,  -610,    -8,    98,   267,   595,   455,
      87,    87,    59,    59,    59,    59,    59,    75,  -610,   253,
    -610,  -610,  -610,  -610,  -610,  -610,   605,  -610,   114,   105,
     606,   609,  -610,   608,   611,   607,    87,  -610,   612,   455,
      87,   -96,  -610,  -610,   119,   210,   210,   206,   210,  -610,
     614,  -610,   613,  -610,    59,  -610,   615,  -610,  -610,     9,
     264,    87,   -35,   -37,   616,   617,    59,    59,    59,    59,
    -610,   620,   260,  -610,  -117,  -610,   -34,   618,   621,   367,
      87,   619,   210,   210,   210,   210,   622,  -610,     9,  -610,
     524,    87,   623,   455,   -28,  -610,   625,  -610,   455,   -14,
    -610,   -99,   584,  -610,   -68,   632,   627,   629,   634,   638,
     626,   628,   630,   631,  -610,  -610,  -610,  -610
};

/* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
    -610,  -610,  -610,   407,  -610,  -610,  -610,  -610,  -610,  -610,
    -393,  -610,  -610,   -45,  -610,  -610,  -610,  -610,  -610,  -610,
    -610,  -610,  -610,  -610,  -610,  -610,  -400,  -610,  -423,  -610,
     113,  -396,  -610,  -610,   -26,  -499,  -176,  -609,  -610,   -69
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -20
static const short int yytable[] =
{
     140,   452,   453,   345,   567,   466,   486,   648,    67,   154,
     635,   303,   476,   472,   473,   468,   666,   624,   200,   625,
     155,   560,   561,   135,    68,   304,   413,   143,   649,   564,
     565,   414,   148,   149,   150,   151,   152,   153,   180,   635,
     469,   158,   414,   160,    69,   414,   522,   668,   190,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   199,   177,
     178,   179,   201,   181,   182,   183,   184,   185,   186,   232,
     233,   602,   603,   414,   549,   525,   445,   362,   637,   595,
     638,   446,   234,   235,   236,   237,   570,   571,   439,   570,
     571,   570,   571,   548,   544,   570,   571,   620,   127,   202,
      70,   623,   346,   347,   348,   349,   414,   350,   639,   570,
     571,   650,    71,   568,   569,   570,   571,   662,   128,   129,
     300,   164,   636,   570,   571,   119,   526,   527,   597,   136,
     137,   665,   165,   363,   301,   577,   302,   120,   364,   365,
     138,   654,   508,   366,   139,   121,   367,   488,   368,   369,
     132,   133,   659,   327,   588,   370,   234,   235,   236,   237,
     328,   371,   372,    72,   238,   333,   334,   335,   336,   601,
     509,    73,   204,   122,   373,   488,   -19,   205,   206,   136,
     137,   207,   208,   209,   586,   210,   211,   123,   212,   488,
     138,   213,   214,   215,   139,   216,   217,   218,   219,   622,
     220,   221,   222,   223,   526,   527,   414,   136,   137,   126,
     534,   524,   224,   225,   226,   543,   414,    74,   138,    75,
     609,   528,   529,   572,   573,   574,   575,   576,   234,   235,
     236,   237,   236,   237,   332,   234,   235,   236,   237,   325,
     487,   613,   326,   488,   626,   339,   614,   627,    76,   234,
     235,   236,   237,   661,   513,   488,    77,   514,   664,   612,
       1,     2,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    78,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    79,    51,    80,    52,   572,   573,   574,   575,   576,
     234,   235,   236,   237,   407,   350,    81,   234,   235,   236,
     237,   628,   459,    53,   629,   278,   234,   235,   236,   237,
     234,   235,   236,   237,    82,    54,    55,    56,    57,    58,
      59,   234,   235,   236,   237,   427,    83,    60,   428,   288,
     234,   235,   236,   237,   234,   235,   236,   237,   297,   130,
     496,   515,   512,   124,   516,    61,   234,   235,   236,   237,
     598,   599,   332,   234,   235,   236,   237,   570,   571,   610,
     234,   235,   236,   237,   517,   519,   647,   518,   414,   523,
     562,   192,   524,   524,    84,    85,   330,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     125,   141,   142,   144,   145,   146,   147,   156,   157,   159,
     161,   162,   163,   166,   176,   187,   188,   189,   191,   290,
     566,   193,   194,   195,   196,   197,   253,   331,   579,   409,
     131,   550,   657,     0,     0,     0,     0,   229,     0,   589,
     474,   653,   344,   230,   231,   263,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     254,   255,   256,   604,   605,   606,   607,   608,   257,   258,
     259,   260,   261,   262,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   289,   380,   298,
     299,   291,   292,   293,   294,   632,   306,   307,   308,   382,
     310,   311,   309,   313,   314,   312,   316,   642,   643,   644,
     645,   317,   318,   319,   340,   341,   322,   320,   321,   329,
     323,   324,   342,   337,   338,   343,   358,   360,   361,   375,
     376,   377,   378,   379,   381,   383,   385,   384,   386,   387,
     388,   389,   390,   391,   392,   393,   401,     0,   520,   402,
     406,   394,   395,     0,   430,     0,     0,   396,   397,   398,
     457,     0,     0,     0,     0,   399,   400,     0,   410,   417,
     416,   418,   403,   404,   405,   412,   415,   419,   420,   421,
     423,   429,   422,   450,   424,   425,   432,   426,   658,     0,
       0,     0,   433,   434,   435,   436,   438,   437,   439,   454,
     442,   443,   444,   447,   458,   449,   451,   460,   462,   448,
     455,   456,   464,   471,   477,   478,   479,   467,   480,   481,
     482,   483,   489,   484,   485,   468,   490,   491,   492,   497,
     493,   495,   502,   504,   498,     0,     0,     0,   499,     0,
     521,   545,     0,     0,   500,   501,   503,   505,   506,   667,
     507,   555,     0,   591,   536,   510,   511,   538,   539,   540,
     537,   535,   541,   542,   546,   552,   551,   556,   547,   553,
     554,   557,   558,   559,   563,   578,   580,   581,   582,   583,
     584,   585,   587,   590,   596,   593,   592,     0,   641,   600,
     594,   646,   652,   611,   615,   616,   617,   669,   670,   618,
     671,   619,   630,   633,   631,   672,   621,   655,   656,   673,
     640,   660,   651,   663,   674,     0,   675,     0,   676,   677
};

static const short int yycheck[] =
{
      69,   394,   395,     5,     4,   405,   429,   124,   139,   120,
     619,   124,   412,   409,   410,   121,   115,   113,    40,   115,
     131,   520,   521,    68,   139,   138,   136,    72,   145,   528,
     529,   141,    77,    78,    79,    80,    81,    82,   107,   648,
     146,    86,   141,    88,   139,   141,   469,   115,   117,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   127,   104,
     105,   106,    84,   108,   109,   110,   111,   112,   113,   138,
     139,   570,   571,   141,   121,   471,   136,     3,   113,   111,
     115,   141,   130,   131,   132,   133,   123,   124,   135,   123,
     124,   123,   124,   141,   487,   123,   124,   596,   119,   121,
     139,   600,   104,   105,   106,   107,   141,   109,   145,   123,
     124,   145,   139,   113,   114,   123,   124,   145,   139,   140,
     124,   120,   621,   123,   124,   138,   117,   118,   136,   120,
     121,   145,   131,    59,   138,   535,   140,    90,    64,    65,
     131,   640,   136,    69,   135,   135,    72,   141,    74,    75,
     117,   118,   651,   135,   547,    81,   130,   131,   132,   133,
     142,    87,    88,   139,   138,   234,   235,   236,   237,   569,
     136,   139,    57,   135,   100,   141,    61,    62,    63,   120,
     121,    66,    67,    68,   136,    70,    71,   135,    73,   141,
     131,    76,    77,    78,   135,    80,    81,    82,    83,   599,
      85,    86,    87,    88,   117,   118,   141,   120,   121,   121,
     145,   141,    97,    98,    99,   145,   141,   139,   131,   139,
     145,   134,   135,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   132,   133,   136,   130,   131,   132,   133,   135,
     138,   136,   138,   141,   125,   290,   141,   128,   139,   130,
     131,   132,   133,   653,   138,   141,   139,   141,   658,   145,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,   139,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,   139,    58,   139,    60,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   108,   109,   139,   130,   131,   132,
     133,   125,   401,    79,   128,   138,   130,   131,   132,   133,
     130,   131,   132,   133,   139,    91,    92,    93,    94,    95,
      96,   130,   131,   132,   133,   135,   139,   103,   138,   138,
     130,   131,   132,   133,   130,   131,   132,   133,   138,     0,
     439,   138,   138,   135,   141,   121,   130,   131,   132,   133,
     113,   114,   136,   130,   131,   132,   133,   123,   124,   136,
     130,   131,   132,   133,   138,   138,   136,   141,   141,   138,
     138,   138,   141,   141,   139,   139,    89,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     135,   120,   120,   120,   120,   120,   120,   120,   120,   120,
     120,   120,   120,   120,   120,   120,   120,   120,   120,   141,
     529,   121,   121,   121,   121,   121,   120,    61,   537,   356,
      63,   497,   648,    -1,    -1,    -1,    -1,   138,    -1,   548,
     112,   114,   116,   138,   137,   120,   138,   138,   138,   138,
     138,   138,   138,   138,   138,   138,   138,   138,   138,   138,
     138,   138,   138,   572,   573,   574,   575,   576,   138,   138,
     138,   138,   138,   138,   138,   138,   138,   138,   138,   138,
     138,   138,   138,   138,   138,   138,   138,   138,   138,   138,
     138,   138,   138,   138,   138,   138,   138,   138,    90,   135,
     135,   141,   141,   141,   141,   614,   135,   135,   135,    90,
     135,   135,   138,   135,   135,   138,   135,   626,   627,   628,
     629,   135,   135,   135,   121,   121,   135,   138,   138,   135,
     138,   138,   121,   138,   138,   121,   121,   121,   121,   121,
     135,   121,   121,   121,   121,   121,   121,   135,    90,   121,
     121,   121,    90,    90,    90,    90,   146,    -1,   110,   146,
     121,   135,   135,    -1,   121,    -1,    -1,   136,   136,   136,
     121,    -1,    -1,    -1,    -1,   141,   141,    -1,   138,   135,
     138,   135,   146,   146,   146,   144,   141,   135,   135,   138,
     135,   144,   138,   143,   138,   138,   136,   138,   114,    -1,
      -1,    -1,   141,   136,   136,   136,   136,   141,   135,   138,
     136,   136,   136,   136,   121,   136,   136,   121,   121,   141,
     138,   138,   121,   138,   138,   121,   121,   146,   121,   121,
     121,   120,   138,   121,   121,   121,   121,   138,   138,   141,
     138,   138,   121,   120,   138,    -1,    -1,    -1,   138,    -1,
     124,   121,    -1,    -1,   138,   138,   138,   138,   138,   115,
     138,   121,    -1,   120,   136,   141,   141,   136,   136,   136,
     141,   144,   136,   136,   136,   136,   141,   121,   144,   138,
     138,   121,   121,   121,   121,   138,   138,   138,   138,   138,
     138,   138,   138,   136,   124,   136,   138,    -1,   121,   144,
     136,   121,   121,   138,   138,   136,   138,   115,   121,   138,
     121,   144,   138,   138,   141,   121,   144,   138,   136,   121,
     144,   138,   144,   138,   138,    -1,   138,    -1,   138,   138
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    58,    60,    79,    91,    92,    93,    94,    95,    96,
     103,   121,   148,   149,   150,   159,   161,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   138,
      90,   135,   135,   135,   135,   135,   121,   119,   139,   140,
       0,   150,   117,   118,   160,   160,   120,   121,   131,   135,
     186,   120,   120,   160,   120,   120,   120,   120,   160,   160,
     160,   160,   160,   160,   120,   131,   120,   120,   160,   120,
     160,   120,   120,   120,   120,   131,   120,   160,   160,   160,
     160,   160,   160,   160,   160,   160,   120,   160,   160,   160,
     186,   160,   160,   160,   160,   160,   160,   120,   120,   120,
     186,   120,   138,   121,   121,   121,   121,   121,   162,   186,
      40,    84,   121,   158,    57,    62,    63,    66,    67,    68,
      70,    71,    73,    76,    77,    78,    80,    81,    82,    83,
      85,    86,    87,    88,    97,    98,    99,   152,   153,   138,
     138,   137,   186,   186,   130,   131,   132,   133,   138,   138,
     138,   138,   138,   138,   138,   138,   138,   138,   138,   138,
     138,   138,   138,   120,   138,   138,   138,   138,   138,   138,
     138,   138,   138,   120,   138,   138,   138,   138,   138,   138,
     138,   138,   138,   138,   138,   138,   138,   138,   138,   138,
     138,   138,   138,   138,   138,   138,   138,   138,   138,   138,
     141,   141,   141,   141,   141,   163,   164,   138,   135,   135,
     124,   138,   140,   124,   138,   156,   135,   135,   135,   138,
     135,   135,   138,   135,   135,   155,   135,   135,   135,   135,
     138,   138,   135,   138,   138,   135,   138,   135,   142,   135,
      89,    61,   136,   186,   186,   186,   186,   138,   138,   160,
     121,   121,   121,   121,   116,     5,   104,   105,   106,   107,
     109,   165,   166,   167,   168,   169,   176,   177,   121,   173,
     121,   121,     3,    59,    64,    65,    69,    72,    74,    75,
      81,    87,    88,   100,   151,   121,   135,   121,   121,   121,
      90,   121,    90,   121,   135,   121,    90,   121,   121,   121,
      90,    90,    90,    90,   135,   135,   136,   136,   136,   141,
     141,   146,   146,   146,   146,   146,   121,   108,   174,   177,
     138,   178,   144,   136,   141,   141,   138,   135,   135,   135,
     135,   138,   138,   135,   138,   138,   138,   135,   138,   144,
     121,   157,   136,   141,   136,   136,   136,   141,   136,   135,
     180,   181,   136,   136,   136,   136,   141,   136,   141,   136,
     143,   136,   157,   157,   138,   138,   138,   121,   121,   186,
     121,   170,   121,   171,   121,   172,   173,   146,   121,   146,
     175,   138,   178,   178,   112,   179,   173,   138,   121,   121,
     121,   121,   121,   120,   121,   121,   175,   138,   141,   138,
     121,   138,   138,   138,   154,   138,   186,   141,   138,   138,
     138,   138,   121,   138,   120,   138,   138,   138,   136,   136,
     141,   141,   138,   138,   141,   138,   141,   138,   141,   138,
     110,   124,   175,   138,   141,   178,   117,   118,   134,   135,
     182,   184,   185,   186,   145,   144,   136,   141,   136,   136,
     136,   136,   136,   145,   157,   121,   136,   144,   141,   121,
     181,   141,   136,   138,   138,   121,   121,   121,   121,   121,
     182,   182,   138,   121,   182,   182,   186,     4,   113,   114,
     123,   124,   125,   126,   127,   128,   129,   173,   138,   186,
     138,   138,   138,   138,   138,   138,   136,   138,   157,   186,
     136,   120,   138,   136,   136,   111,   124,   136,   113,   114,
     144,   173,   182,   182,   186,   186,   186,   186,   186,   145,
     136,   138,   145,   136,   141,   138,   136,   138,   138,   144,
     182,   144,   173,   182,   113,   115,   125,   128,   125,   128,
     138,   141,   186,   138,   183,   184,   182,   113,   115,   145,
     144,   121,   186,   186,   186,   186,   121,   136,   124,   145,
     145,   144,   121,   114,   182,   138,   136,   183,   114,   182,
     138,   173,   145,   138,   173,   145,   115,   115,   115,   115,
     121,   121,   121,   121,   138,   138,   138,   138
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)		\
   ((Current).first_line   = (Rhs)[1].first_line,	\
    (Current).first_column = (Rhs)[1].first_column,	\
    (Current).last_line    = (Rhs)[N].last_line,	\
    (Current).last_column  = (Rhs)[N].last_column)
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if defined (YYMAXDEPTH) && YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  register short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;


  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 7:
#line 250 "parser.y"
    { cout << yyvsp[-1].mystring << endl << flush; ;}
    break;

  case 8:
#line 252 "parser.y"
    { cout << "Automata in memory:" << endl << flush; 
			for (map <string, automaton*>::const_iterator i = pautmap.begin(); i!= pautmap.end(); ++i)
			{
				cout << i->first << " ";
				cout << "(" << (i->second)->name << "):";
				(i->second)->print_size();
//				cout << endl;
			};
     cout << endl << "Constants in memory:" << endl << flush;
     for (map <string, Rational_Linear_Expression>::const_iterator i = linexmap.begin(); i!= linexmap.end(); ++i)
         {
            cout << i->first << " := " << i->second << endl << flush;
            //cout << endl;
         };
      
/*	map <string, unsigned int> varmap;
	map <string, Rational_Linear_Expression> linexmap;
   map <string, pair <symb_states_type, automaton*> > sstatesmap;
   map <string, pair <state_relation, pair <automaton*, automaton*> > > sstate_relationmap;  
	map <string, automaton*> pautmap;*/
   
        cout << endl << "Symbolic states in memory:" << endl << flush;
     for (map <string, pair <symb_states_type, automaton*> >::const_iterator i = sstatesmap.begin(); i!= sstatesmap.end(); ++i)
         {
            cout << i->first << " : " << i->second.first.size() << " locs, " << i->second.first.get_memory() << " bytes" << endl << flush;
//            cout << endl;
         };
         cout << endl;
	;}
    break;

  case 9:
#line 286 "parser.y"
    { str=yyvsp[-1].mystring;
        if (sstatesmap.find(str)!=sstatesmap.end())
        {
          sstatesmap[yyvsp[-3].mystring]=sstatesmap[yyvsp[-1].mystring];
        }
        else if (sstate_relationmap.find(str)!=sstate_relationmap.end())
        {
          sstate_relationmap[yyvsp[-3].mystring]=sstate_relationmap[yyvsp[-1].mystring];
        }
        else if (pautmap.find(str)!=pautmap.end())
        {
					paut = new automaton(*pautmap[yyvsp[-1].mystring]);
					paut->name=yyvsp[-3].mystring;
          pautmap[yyvsp[-3].mystring]=paut;
        }
        else
          {yyerror("Identifier " + str + " not found.");}; 
      ;}
    break;

  case 10:
#line 305 "parser.y"
    { 
  		  str=yyvsp[-3].mystring;
        if (sstatesmap.find(str)!=sstatesmap.end())
        {
            if (sstatesmap[yyvsp[-3].mystring].second != NULL)
            {
			 cout << str << " = " << sstatesmap[yyvsp[-3].mystring].second->name << "." << "{";
					sstatesmap[yyvsp[-3].mystring].first.print_phaver(cout);
			 cout << "};" << endl;
            }
            else
            {
					sstatesmap[yyvsp[-3].mystring].first.print_phaver(cout);
            }
        }
        else if (sstate_relationmap.find(str)!=sstate_relationmap.end())
        {
          sstate_relationmap[yyvsp[-3].mystring].first.print();
        }
        else if (pautmap.find(str)!=pautmap.end())
        {
					pautmap[yyvsp[-3].mystring]->print();
        }
        else
          {yyerror("Identifier " + str + " not found.");}; 
			;}
    break;

  case 11:
#line 332 "parser.y"
    { if (sstatesmap.find(yyvsp[-8].mystring)!=sstatesmap.end())
				{
//cout << "#############################" << (*$7)==2 << endl;				
					file_out.open( yyvsp[-4].mystring );
								// sstatesmap[$1].first.print(sstatesmap[$1].second->get_loc_names());
					file_out.precision(FP_PRECISION);
					if (atoi(yyvsp[-2].mystring) == 1) // constraint form
						sstatesmap[yyvsp[-8].mystring].first.print_con_fp_raw(file_out);
					else if (atoi(yyvsp[-2].mystring) == 2) // generator form
						sstatesmap[yyvsp[-8].mystring].first.print_gen_fp_raw(file_out);
					else if (atoi(yyvsp[-2].mystring) == 3) // debug form
						sstatesmap[yyvsp[-8].mystring].first.print();
					else if (atoi(yyvsp[-2].mystring) == 4) // debug form
						sstatesmap[yyvsp[-8].mystring].first.print(sstatesmap[yyvsp[-8].mystring].second->get_loc_names());
  					else
					{
			   		str=yyvsp[-8].mystring;
						file_out << str << " = " << sstatesmap[yyvsp[-8].mystring].second->name << "." << "{";
								sstatesmap[yyvsp[-8].mystring].first.print_phaver(file_out);
						file_out << "};";
					}
					file_out.close();
				}      
				else if (sstate_relationmap.find(yyvsp[-8].mystring)!=sstate_relationmap.end())
				{
					file_out.open( yyvsp[-4].mystring );
								//sstate_relationmap[$1].first.print();
					file_out << "error, feature not implemented yet";
					file_out.close();
					cout << "hello";
				}
            else if (pautmap.find(yyvsp[-8].mystring)!=pautmap.end())
            {
					file_out.open( yyvsp[-4].mystring );
					if (atoi(yyvsp[-2].mystring) == 1) // dot form (graphviz)
	  				  pautmap[yyvsp[-8].mystring]->print_dot(file_out);
               else
	  				  pautmap[yyvsp[-8].mystring]->print_phaver(file_out);
					file_out.close();
            }
        else yyerror("Unknown identifier '" + (string)yyvsp[-8].mystring +"'."); 
			;}
    break;

  case 12:
#line 375 "parser.y"
    {  throw_warning("Command save_gen_fp is deprecated. Use print(\"fname\",2) instead.");
			if (sstatesmap.find(yyvsp[-6].mystring)!=sstatesmap.end())
				{
					file_out.open( yyvsp[-2].mystring );
								// sstatesmap[$1].first.print(sstatesmap[$1].second->get_loc_names());
					file_out.precision(FP_PRECISION);
					sstatesmap[yyvsp[-6].mystring].first.print_gen_fp_raw(file_out);
					file_out.close();
				}      
				else if (sstate_relationmap.find(yyvsp[-6].mystring)!=sstate_relationmap.end())
				{
					file_out.open( outfilename.c_str() );
								//sstate_relationmap[$1].first.print();
					file_out << "test";
					file_out.close();
					cout << "hello";
				}
        else yyerror("Unknown identifier '" + (string)yyvsp[-6].mystring +"'."); 
			;}
    break;

  case 13:
#line 395 "parser.y"
    { throw_warning("Command save_con_fp is deprecated. Use print(\"fname\",1) instead.");
		  if (sstatesmap.find(yyvsp[-6].mystring)!=sstatesmap.end())
				{
					file_out.open( yyvsp[-2].mystring );
								// sstatesmap[$1].first.print(sstatesmap[$1].second->get_loc_names());
					file_out.precision(FP_PRECISION);
					sstatesmap[yyvsp[-6].mystring].first.print_con_fp_raw(file_out);
					file_out.close();
				}      
							else if (sstate_relationmap.find(yyvsp[-6].mystring)!=sstate_relationmap.end())
				{
					file_out.open( outfilename.c_str() );
								//sstate_relationmap[$1].first.print();
					file_out << "test";
					file_out.close();
					cout << "hello";
				}
        else yyerror("Unknown identifier '" + (string)yyvsp[-6].mystring +"'."); 
			;}
    break;

  case 14:
#line 415 "parser.y"
    { if (sstatesmap.find(yyvsp[-6].mystring)!=sstatesmap.end())
				{
					file_out.open( yyvsp[-2].mystring );
					file_out.precision(FP_PRECISION);
					clock_val_set temp_cvs=sstatesmap[yyvsp[-6].mystring].first.union_over_locations();
					temp_cvs.print_con_fp_raw(file_out);
					file_out.close();
				}      
							else if (sstate_relationmap.find(yyvsp[-6].mystring)!=sstate_relationmap.end())
				{
					file_out.open( outfilename.c_str() );
								//sstate_relationmap[$1].first.print();
					file_out << "test";
					file_out.close();
					cout << "hello";
				}
        else yyerror("Unknown identifier '" + (string)yyvsp[-6].mystring +"'."); 
			;}
    break;

  case 15:
#line 436 "parser.y"
    { 
				if (pautmap.find(yyvsp[-1].mystring)!=pautmap.end())
				{
               paut=pautmap[yyvsp[-1].mystring];
				}
            else
					{yyerror("Automaton '" + (string)yyvsp[-1].mystring + "' not found.");}; 
         
            ;}
    break;

  case 16:
#line 445 "parser.y"
    { sstatesmap[yyvsp[-8].mystring]=make_pair(*yyvsp[-2].symb_state,pautmap[yyvsp[-6].mystring]);;}
    break;

  case 17:
#line 447 "parser.y"
    {
				if (sstatesmap.find(yyvsp[-1].mystring)!=sstatesmap.end()) 
				{
					psymb_state=&sstatesmap[yyvsp[-1].mystring].first;
					paut=sstatesmap[yyvsp[-1].mystring].second;
				}
				else 
				{
					yyerror("Unknown state identifier '" + (string)yyvsp[-1].mystring +"'.");
					psymb_state=NULL;
				};
			;}
    break;

  case 18:
#line 460 "parser.y"
    { 
         if (yyvsp[-2].crs!=NULL)
         {
            if (sstatesmap.find(yyvsp[-7].mystring)!=sstatesmap.end())
               sstatesmap[yyvsp[-7].mystring].first.remove_space_dimensions(*yyvsp[-2].crs);
            else yyerror("Unknown identifier '" + (string)yyvsp[-7].mystring +"'."); 
			};
         psymb_state=NULL;
      ;}
    break;

  case 19:
#line 470 "parser.y"
    {
				if (sstatesmap.find(yyvsp[-1].mystring)!=sstatesmap.end()) 
				{
					psymb_state=&sstatesmap[yyvsp[-1].mystring].first;
					paut=sstatesmap[yyvsp[-1].mystring].second;
				}
				else 
				{
					psymb_state=NULL;
               paut=NULL;
               if (pautmap.find(yyvsp[-1].mystring)!=pautmap.end())
               {
                  paut=pautmap[yyvsp[-1].mystring];
               }
               else
					 yyerror("Unknown identifier '" + (string)yyvsp[-1].mystring +"'.");
				};
			;}
    break;

  case 20:
#line 489 "parser.y"
    { 
         if (yyvsp[-2].crs!=NULL)
         {
            if (psymb_state!=NULL)
               sstatesmap[yyvsp[-7].mystring].first.project_to_vars(*yyvsp[-2].crs);
            else if (paut!=NULL)
               paut->project_to_vars(*yyvsp[-2].crs);
            else yyerror("Unknown identifier '" + (string)yyvsp[-7].mystring +"'."); 
			};
         psymb_state=NULL;
         paut=NULL;
      ;}
    break;

  case 21:
#line 502 "parser.y"
    { str=yyvsp[-4].mystring;
        if (sstatesmap.find(str)!=sstatesmap.end())
        {
          sstates=sstatesmap[str].first;
          clock_ref_set crs=sstatesmap[str].second->parameters;
          sstates.remove_space_dimensions(crs.complement(0,sstatesmap[str].second->dim));
          clock_val_set tempcvs;
          if (yyvsp[-2].mybool)
          {
            cout << "Parameters in any of the locations:" << endl;
            tempcvs=sstates.union_over_locations();
          }
          else
          {
            cout << "Parameters common to all locations:" << endl;
            tempcvs=sstates.intersection_over_locations();
          };
          tempcvs.print();
        }
        else
          {yyerror("Identifier " + (string)yyvsp[-4].mystring + " not found.");}; ;}
    break;

  case 22:
#line 524 "parser.y"
    { if (sstatesmap.find(yyvsp[-3].mystring)!=sstatesmap.end())
        { mycvs=sstatesmap[yyvsp[-3].mystring].first.union_over_locations();
          mycvs.print(sstatesmap[yyvsp[-3].mystring].first.var_names);
					mycvs.print_gen_fp_raw(cout);
				}
        else yyerror("Unknown identifier '" + (string)yyvsp[-3].mystring +"'."); ;}
    break;

  case 23:
#line 531 "parser.y"
    { if (sstatesmap.find(yyvsp[-3].mystring)!=sstatesmap.end())
        { mycvs=sstatesmap[yyvsp[-3].mystring].first.intersection_over_locations();
          mycvs.print(sstatesmap[yyvsp[-3].mystring].first.var_names);
					mycvs.print_gen_fp_raw(cout);
				}
        else yyerror("Unknown identifier '" + (string)yyvsp[-3].mystring +"'."); ;}
    break;

  case 24:
#line 538 "parser.y"
    { if (sstatesmap.find(yyvsp[-3].mystring)!=sstatesmap.end())
        { mycvs=sstatesmap[yyvsp[-3].mystring].first.union_over_locations();
//cout << mycvs;        
          psymb_state=new symb_states_type(sstatesmap[yyvsp[-3].mystring].first.var_names);
          psymb_state->add("$",mycvs);
          sstatesmap[yyvsp[-5].mystring]=make_pair(*psymb_state,sstatesmap[yyvsp[-3].mystring].second);
          delete psymb_state;
        }
        else yyerror("Unknown identifier '" + (string)yyvsp[-5].mystring +"'."); ;}
    break;

  case 25:
#line 548 "parser.y"
    { if (sstatesmap.find(yyvsp[-3].mystring)!=sstatesmap.end())
        { mycvs=sstatesmap[yyvsp[-3].mystring].first.intersection_over_locations();
//cout << mycvs;        
          psymb_state=new symb_states_type(sstatesmap[yyvsp[-3].mystring].first.var_names);
          psymb_state->add("$",mycvs);
          sstatesmap[yyvsp[-5].mystring]=make_pair(*psymb_state,sstatesmap[yyvsp[-3].mystring].second);
          delete psymb_state;
        }
        else yyerror("Unknown identifier '" + (string)yyvsp[-5].mystring +"'."); ;}
    break;

  case 26:
#line 558 "parser.y"
    { if (sstatesmap.find(yyvsp[-3].mystring)!=sstatesmap.end())
        { 
//cout << mycvs;        
//          psymb_state=new symb_states_type(sstatesmap[$3].first.var_names);
          sstates=sstatesmap[yyvsp[-3].mystring].first.merge_splitted();
          sstatesmap[yyvsp[-5].mystring]=make_pair(sstates,(automaton*)NULL);
	  //          delete psymb_state;
        }
        else yyerror("Unknown identifier '" + (string)yyvsp[-5].mystring +"'."); ;}
    break;

  case 27:
#line 569 "parser.y"
    { if (sstatesmap.find(yyvsp[-6].mystring)!=sstatesmap.end())
        {
          if (sstatesmap.find(yyvsp[-2].mystring)!=sstatesmap.end())
          { sstatesmap[yyvsp[-6].mystring].first.intersection_assign(sstatesmap[yyvsp[-2].mystring].first,true);
          }
          else yyerror("Unknown identifier '" + (string)yyvsp[-2].mystring +"'.");
          }
        else yyerror("Unknown identifier '" + (string)yyvsp[-6].mystring +"'."); 
      ;}
    break;

  case 28:
#line 580 "parser.y"
    { if (sstatesmap.find(yyvsp[-6].mystring)!=sstatesmap.end())
        {
          if (sstatesmap.find(yyvsp[-2].mystring)!=sstatesmap.end())
          { sstatesmap[yyvsp[-6].mystring].first.difference_assign(sstatesmap[yyvsp[-2].mystring].first,true);
          }
          else yyerror("Unknown identifier '" + (string)yyvsp[-2].mystring +"'.");
          }
        else yyerror("Unknown identifier '" + (string)yyvsp[-6].mystring +"'."); 
      ;}
    break;

  case 29:
#line 591 "parser.y"
    { if (sstatesmap.find(yyvsp[-6].mystring)!=sstatesmap.end())
        {
          if (sstatesmap.find(yyvsp[-2].mystring)!=sstatesmap.end())
          { if (sstatesmap[yyvsp[-6].mystring].first.contains(sstatesmap[yyvsp[-2].mystring].first,true))
						  cout << yyvsp[-6].mystring << " contains " << yyvsp[-2].mystring;
						else
						  cout << yyvsp[-6].mystring << " does not contain " << yyvsp[-2].mystring;
          }
          else yyerror("Unknown identifier '" + (string)yyvsp[-2].mystring +"'.");
          }
        else yyerror("Unknown identifier '" + (string)yyvsp[-6].mystring +"'."); 
      ;}
    break;

  case 30:
#line 604 "parser.y"
    { if (sstatesmap.find(yyvsp[-3].mystring)!=sstatesmap.end())
        { if (sstatesmap[yyvsp[-3].mystring].first.is_empty())
            cout << "empty";
          else
            cout << "not empty";
          }
        else yyerror("Unknown identifier '" + (string)yyvsp[-3].mystring +"'.");
      ;}
    break;

  case 31:
#line 613 "parser.y"
    { if (sstatesmap.find(yyvsp[-8].mystring)!=sstatesmap.end())
        { 
		  		sstatesmap[yyvsp[-8].mystring].first.rename_variable((string)yyvsp[-4].mystring,(string)yyvsp[-2].mystring);
				// remove the reference to any automaton because now it's changed
				sstatesmap[yyvsp[-8].mystring].second=NULL;
        }
        else yyerror("Unknown identifier '" + (string)yyvsp[-8].mystring +"'.");
      ;}
    break;

  case 32:
#line 625 "parser.y"
    { sstate_relationmap[yyvsp[-8].mystring]=make_pair(state_relation(),make_pair(pautmap[yyvsp[-4].mystring],pautmap[yyvsp[-2].mystring]));
        pautmap[yyvsp[-4].mystring]->is_simulation(*pautmap[yyvsp[-2].mystring],&(sstate_relationmap[yyvsp[-8].mystring].first)); ;}
    break;

  case 33:
#line 628 "parser.y"
    { sstatesmap[yyvsp[-8].mystring]=make_pair(sstate_relationmap[yyvsp[-6].mystring].first.project_to_first(sstatesmap[yyvsp[-2].mystring].first),sstate_relationmap[yyvsp[-6].mystring].second.first); 
			  sstatesmap[yyvsp[-8].mystring].first.var_names_assign(sstate_relationmap[yyvsp[-6].mystring].second.first->get_var_names());
			;}
    break;

  case 34:
#line 632 "parser.y"
    { sstatesmap[yyvsp[-5].mystring]=make_pair(sstate_relationmap[yyvsp[-3].mystring].first.project_to_first(sstate_relationmap[yyvsp[-3].mystring].second.first->dim),sstate_relationmap[yyvsp[-3].mystring].second.first); 
			  sstatesmap[yyvsp[-5].mystring].first.var_names_assign(sstate_relationmap[yyvsp[-3].mystring].second.first->get_var_names());
			;}
    break;

  case 35:
#line 644 "parser.y"
    {
         // create automaton vector
         aut_vec=vector<automaton>();
         for (list<string>::const_iterator it=yyvsp[-2].pident_list->begin();it!=yyvsp[-2].pident_list->end();++it)
         {
				if (pautmap.find(*it)!=pautmap.end())
				{
               aut_vec.push_back(*pautmap[*it]);
				}
            else
					{yyerror("Automaton '" + *it + "' not found.");}; 
         }
         //now compose
         paut=new automaton(); 
         compose_by_vector(*paut,aut_vec);
			pautmap[yyvsp[-6].mystring]=paut;       
         // delete aut_vec
         aut_vec=vector<automaton>();
      ;}
    break;

  case 36:
#line 664 "parser.y"
    {					
				if (pautmap.find(*(yyvsp[-1].pident_list->begin()))!=pautmap.end())
				{
               paut=new automaton(*pautmap[*(yyvsp[-1].pident_list->begin())]); 
               automaton* paut_result=new automaton();
               list<string>::const_iterator list_it=yyvsp[-1].pident_list->begin();
               ++list_it; // go to second one
               while (list_it!=yyvsp[-1].pident_list->end())
               {
      		     if (pautmap.find(*list_it)!=pautmap.end())
		      	  {
					    compose_discrete(*paut_result,*paut,*pautmap[*list_it]); 
                   swap(paut,paut_result);
                 }
                 else
   					{yyerror("Automaton '" + *list_it + "' not found.");}; 
                 ++list_it;
               }
               delete paut_result;
					pautmap[yyvsp[-3].mystring]=paut;       
				}
            else
					{yyerror("Automaton '" + *(yyvsp[-1].pident_list->begin()) + "' not found.");}; 
      ;}
    break;

  case 37:
#line 689 "parser.y"
    {
				if (pautmap.find(yyvsp[-6].mystring)!=pautmap.end())
				{
					file_out.open( yyvsp[-2].mystring );
					file_out.precision(FP_PRECISION);
					pautmap[yyvsp[-6].mystring]->print_inv_fp_raw(file_out);
					file_out.close();
				}
				else
					{yyerror("Automaton '" + (string)yyvsp[-6].mystring + "' not found.");}; 
			;}
    break;

  case 38:
#line 701 "parser.y"
    {
				if (pautmap.find(yyvsp[-6].mystring)!=pautmap.end())
				{
					file_out.open( yyvsp[-2].mystring );
					file_out.precision(FP_PRECISION);
					pautmap[yyvsp[-6].mystring]->print_surface_fp_raw(file_out);
					file_out.close();
				}
				else
					{yyerror("Automaton '" + (string)yyvsp[-6].mystring + "' not found.");}; 
			;}
    break;

  case 39:
#line 713 "parser.y"
    {
				psymb_state=NULL;
				if (pautmap.find(yyvsp[-5].mystring)!=pautmap.end())
				{
					paut=pautmap[yyvsp[-5].mystring];
				}
				else
					{yyerror("Automaton '" + (string)yyvsp[-5].mystring + "' not found.");}; 
			;}
    break;

  case 40:
#line 723 "parser.y"
    {
				if (pautmap.find(yyvsp[-13].mystring)!=pautmap.end())
				{
					paut=pautmap[yyvsp[-13].mystring];
					file_out.open( yyvsp[-9].mystring );
					file_out.precision(FP_PRECISION);
					if (sstatesmap.find(yyvsp[-2].mystring)!=sstatesmap.end())
					{ 
						paut->print_graph(file_out, *yyvsp[-5].crs, sstatesmap[yyvsp[-2].mystring].first);
          }
					else yyerror("Unknown identifier '" + (string)yyvsp[-2].mystring +"'.");					
					file_out.close();
				}
				else
					{yyerror("Automaton '" + (string)yyvsp[-13].mystring + "' not found.");}; 
			;}
    break;

  case 41:
#line 740 "parser.y"
    {
				if (pautmap.find(yyvsp[-3].mystring)!=pautmap.end())
				{
					pautmap[yyvsp[-3].mystring]->reverse();
				}
				else
					{yyerror("Automaton '" + (string)yyvsp[-3].mystring + "' not found.");}; 
			;}
    break;

  case 42:
#line 749 "parser.y"
    {
				if (pautmap.find(yyvsp[-6].mystring)!=pautmap.end())
				{
					pautmap[yyvsp[-6].mystring]->add_label((string)yyvsp[-2].mystring);
				}
				else
					{yyerror("Automaton '" + (string)yyvsp[-6].mystring + "' not found.");}; 
			;}
    break;

  case 43:
#line 758 "parser.y"
    { 
				if (pautmap.find(yyvsp[-6].mystring)!=pautmap.end())
				{
					sstatesmap[yyvsp[-8].mystring]=make_pair(pautmap[yyvsp[-6].mystring]->get_reach_set_forwarditer(atoi(yyvsp[-2].mystring)),pautmap[yyvsp[-6].mystring]);
				}
				else
					{yyerror("Automaton '" + (string)yyvsp[-6].mystring + "' not found.");}; 
			;}
    break;

  case 44:
#line 767 "parser.y"
    { 
				if (pautmap.find(yyvsp[-3].mystring)!=pautmap.end())
				{
               sstatesmap[yyvsp[-5].mystring]=make_pair(pautmap[yyvsp[-3].mystring]->get_reach_set(),pautmap[yyvsp[-3].mystring]);
				}
				else
					{yyerror("Automaton '" + (string)yyvsp[-3].mystring + "' not found.");}; 
			;}
    break;

  case 45:
#line 776 "parser.y"
    { 
				if (pautmap.find(yyvsp[-6].mystring)!=pautmap.end())
				{
					paut=pautmap[yyvsp[-6].mystring]; 
				}
				else
				{
					yyerror("Automaton '" + (string)yyvsp[-6].mystring + "' not found.");
					paut = NULL;
				}; 
				if (paut!=NULL)
				{
					if (sstatesmap.find(yyvsp[-2].mystring)!=sstatesmap.end())
					{ 
						paut->ini_states_assign(sstatesmap[yyvsp[-2].mystring].first); 
          }
					else yyerror("Unknown identifier '" + (string)yyvsp[-2].mystring +"'.");					
				};
			;}
    break;

  case 46:
#line 796 "parser.y"
    { 
				if (pautmap.find(yyvsp[-6].mystring)!=pautmap.end())
				{
					paut=pautmap[yyvsp[-6].mystring]; 
				}
				else
				{
					yyerror("Automaton '" + (string)yyvsp[-6].mystring + "' not found.");
					paut = NULL;
				}; 
				if (paut!=NULL)
				{
					if (sstatesmap.find(yyvsp[-2].mystring)!=sstatesmap.end())
					{ 
						paut->invariant_assign(sstatesmap[yyvsp[-2].mystring].first); 
          }
					else yyerror("Unknown identifier '" + (string)yyvsp[-2].mystring +"'.");					
				};
			;}
    break;

  case 47:
#line 816 "parser.y"
    { 
				if (pautmap.find(yyvsp[-6].mystring)!=pautmap.end())
				{
					paut=pautmap[yyvsp[-6].mystring]; 
				}
				else
				{
					yyerror("Automaton '" + (string)yyvsp[-6].mystring + "' not found.");
					paut = NULL;
				}; 
				if (paut!=NULL)
				{
					if (sstatesmap.find(yyvsp[-2].mystring)!=sstatesmap.end())
					{ 
                  symb_states_type dummystates;
                  bool dummybool;
						sstatesmap[yyvsp[-8].mystring]=make_pair(paut->get_reach_set(sstatesmap[yyvsp[-2].mystring].first,dummystates,dummybool),paut); 
          }
					else yyerror("Unknown identifier '" + (string)yyvsp[-2].mystring +"'.");					
				};
			;}
    break;

  case 48:
#line 838 "parser.y"
    { 
				if (pautmap.find(yyvsp[-6].mystring)!=pautmap.end())
				{
					paut=pautmap[yyvsp[-6].mystring]; 
				}
				else
				{
					yyerror("Automaton '" + (string)yyvsp[-6].mystring + "' not found.");
					paut = NULL;
				}; 
				if (paut!=NULL)
				{
					if (sstatesmap.find(yyvsp[-2].mystring)!=sstatesmap.end())
					{ 
					  sstates.clear();
						if (paut->is_reachable(sstatesmap[yyvsp[-2].mystring].first,sstates))
							cout << (string)yyvsp[-2].mystring << " is reachable." << endl << flush;
						else
							cout << (string)yyvsp[-2].mystring << " not reachable." << endl << flush;
						sstatesmap[yyvsp[-8].mystring]=make_pair(sstates,paut);          
}
					else yyerror("Unknown identifier '" + (string)yyvsp[-2].mystring +"'.");					
				};
			;}
    break;

  case 49:
#line 863 "parser.y"
    { 
				if (pautmap.find(yyvsp[-6].mystring)!=pautmap.end())
				{
					paut=pautmap[yyvsp[-6].mystring]; 
				}
				else
				{
					yyerror("Automaton '" + (string)yyvsp[-6].mystring + "' not found.");
					paut = NULL;
				}; 
				if (paut!=NULL)
				{
					if (sstatesmap.find(yyvsp[-2].mystring)!=sstatesmap.end())
					{ 
					  sstates.clear();
						if (paut->is_reachable_fb(sstatesmap[yyvsp[-2].mystring].first,sstates))
							cout << (string)yyvsp[-2].mystring << " is reachable." << endl << flush;
						else
							cout << (string)yyvsp[-2].mystring << " not reachable." << endl << flush;
						sstatesmap[yyvsp[-8].mystring]=make_pair(sstates,paut);          
}
					else yyerror("Unknown identifier '" + (string)yyvsp[-2].mystring +"'.");					
				};
			;}
    break;

  case 50:
#line 888 "parser.y"
    { 
				if (pautmap.find(yyvsp[-8].mystring)!=pautmap.end())
				{
					paut=pautmap[yyvsp[-8].mystring]; 
				}
				else
				{
					yyerror("Automaton '" + (string)yyvsp[-8].mystring + "' not found.");
					paut = NULL;
				}; 
				if (paut!=NULL)
				{
					if (sstatesmap.find(yyvsp[-4].mystring)!=sstatesmap.end())
					{ 
					  sstates.clear();
						if (is_reachable_DHR(*paut,sstatesmap[yyvsp[-4].mystring].first,yyvsp[-2].linexp->rat_inhomogeneous_term(),sstates))
							cout << (string)yyvsp[-4].mystring << " is reachable." << endl << flush;
						else
							cout << (string)yyvsp[-4].mystring << " not reachable." << endl << flush;
						sstatesmap[yyvsp[-10].mystring]=make_pair(sstates,paut);          
}
					else yyerror("Unknown identifier '" + (string)yyvsp[-4].mystring +"'.");					
				};
			;}
    break;

  case 51:
#line 913 "parser.y"
    { 
				if (pautmap.find(yyvsp[-4].mystring)!=pautmap.end())
				{
					if (pautmap.find(yyvsp[-2].mystring)!=pautmap.end())
					{
						pautmap[yyvsp[-4].mystring]->is_simulation(*pautmap[yyvsp[-2].mystring]); 
					}
					else
						{yyerror("Automaton '" + (string)yyvsp[-2].mystring + "' not found.");}; 
				}
				else
					{yyerror("Automaton '" + (string)yyvsp[-4].mystring + "' not found.");}; 
			;}
    break;

  case 52:
#line 927 "parser.y"
    { 
				if (pautmap.find(yyvsp[-4].mystring)!=pautmap.end())
				{
					if (pautmap.find(yyvsp[-2].mystring)!=pautmap.end())
					{
						pautmap[yyvsp[-4].mystring]->is_simulation(*pautmap[yyvsp[-2].mystring],NULL,true); 
					}
					else
						{yyerror("Automaton '" + (string)yyvsp[-2].mystring + "' not found.");}; 
				}
				else
					{yyerror("Automaton '" + (string)yyvsp[-4].mystring + "' not found.");}; 
			;}
    break;

  case 53:
#line 941 "parser.y"
    { is_ag_simulation(*pautmap[yyvsp[-8].mystring],*pautmap[yyvsp[-6].mystring],*pautmap[yyvsp[-4].mystring],*pautmap[yyvsp[-2].mystring]); ;}
    break;

  case 54:
#line 943 "parser.y"
    { is_agc_simulation(*pautmap[yyvsp[-8].mystring],*pautmap[yyvsp[-6].mystring],*pautmap[yyvsp[-4].mystring],*pautmap[yyvsp[-2].mystring]); ;}
    break;

  case 55:
#line 945 "parser.y"
    { refine_loc_deriv(*pautmap[yyvsp[-3].mystring]); ;}
    break;

  case 56:
#line 947 "parser.y"
    {       
      if ((string)yyvsp[-4].mystring=="carth_center")
        ref_meth=carth_center;
      else if ((string)yyvsp[-4].mystring=="carth0_center")
        ref_meth=carth0_center;
      else if ((string)yyvsp[-4].mystring=="carth1_center")
        ref_meth=carth1_center;
      else if ((string)yyvsp[-4].mystring=="deriv_center")
        ref_meth=deriv_center;
			else if ((string)yyvsp[-4].mystring=="jacob_center")
        ref_meth=jacob_center;
      else if ((string)yyvsp[-4].mystring=="deriv_dcenter")
        ref_meth=deriv_dcenter;
			else if ((string)yyvsp[-4].mystring=="jacob_dcenter")
        ref_meth=jacob_dcenter;   
			paut=pautmap[yyvsp[-10].mystring];
			refine_locs(*paut,paut->get_label_ref((string)yyvsp[-6].mystring),ref_meth,atoi(yyvsp[-2].mystring));  ;}
    break;

  case 57:
#line 965 "parser.y"
    {       
			paut=pautmap[yyvsp[-6].mystring];
			refine_states(*paut,sstatesmap[yyvsp[-2].mystring].first);  ;}
    break;

  case 58:
#line 968 "parser.y"
    { paut=pautmap[yyvsp[-2].mystring]; ;}
    break;

  case 59:
#line 969 "parser.y"
    {
				REFINE_CONSTRAINTRATPAIRLIST = *yyvsp[-4].pconstraint_rat_pair_list;
				delete yyvsp[-4].pconstraint_rat_pair_list;
				REFINEMENT_LABEL = paut->get_label_ref((string)yyvsp[-2].mystring);
			;}
    break;

  case 60:
#line 975 "parser.y"
    { 
				if (pautmap.find(yyvsp[-3].mystring)!=pautmap.end())
				{
					sstatesmap[yyvsp[-5].mystring]=make_pair(pautmap[yyvsp[-3].mystring]->get_ini_states(),pautmap[yyvsp[-3].mystring]);
				}
				else
					{yyerror("Automaton '" + (string)yyvsp[-3].mystring + "' not found.");}; 
			;}
    break;

  case 61:
#line 984 "parser.y"
    { 
				if (pautmap.find(yyvsp[-3].mystring)!=pautmap.end())
				{
					sstatesmap[yyvsp[-5].mystring]=make_pair(pautmap[yyvsp[-3].mystring]->get_invariants(),pautmap[yyvsp[-3].mystring]);
				}
				else
					{yyerror("Automaton '" + (string)yyvsp[-3].mystring + "' not found.");}; 
			;}
    break;

  case 62:
#line 993 "parser.y"
    { 
				if (pautmap.find(yyvsp[-6].mystring)!=pautmap.end())
					if (sstatesmap.find(yyvsp[-2].mystring)!=sstatesmap.end())
					{
						pautmap[yyvsp[-6].mystring]->unlock_surface_locations(sstatesmap[yyvsp[-2].mystring].first);
					}      
					else yyerror("Unknown identifier '" + (string)yyvsp[-2].mystring +"'."); 
				else
					{yyerror("Automaton '" + (string)yyvsp[-6].mystring + "' not found.");}; 
			;}
    break;

  case 63:
#line 1004 "parser.y"
    { 
				if (pautmap.find(yyvsp[-3].mystring)!=pautmap.end())
					pautmap[yyvsp[-3].mystring]->unlock_locations();
				else
					{yyerror("Automaton '" + (string)yyvsp[-3].mystring + "' not found.");}; 
			;}
    break;

  case 64:
#line 1011 "parser.y"
    { 
				psymb_state=NULL;
				if (pautmap.find(yyvsp[-2].mystring)!=pautmap.end())
					paut=pautmap[yyvsp[-2].mystring];
				else
					{yyerror("Automaton '" + (string)yyvsp[-2].mystring + "' not found.");}; 
			;}
    break;

  case 65:
#line 1019 "parser.y"
    {
				set_REFINE_DHR_VARS(*yyvsp[-4].crs,*yyvsp[-2].crs);
				delete yyvsp[-4].crs; delete yyvsp[-2].crs;
			;}
    break;

  case 66:
#line 1026 "parser.y"
    {
			if (psymb_state!=NULL)
			{
				pcrs = new clock_ref_set;
//cout << psymb_state->var_names;
				if (psymb_state->var_names.contains_name((string)yyvsp[0].mystring))
				{
					pcrs->insert(psymb_state->var_names.get_id((string)yyvsp[0].mystring));
					yyval.crs=pcrs;
				}
				else
				{ 
					yyerror("Unknown state variable '" + (string)yyvsp[0].mystring +"'."); delete pcrs; yyval.crs=NULL; 
				}; 
			}
			else if (paut!=NULL)
			{
				pcrs = new clock_ref_set;
				if (paut->var_id_map.contains_name((string)yyvsp[0].mystring))
				{
					pcrs->insert(paut->var_id_map.get_id((string)yyvsp[0].mystring));
					yyval.crs=pcrs;
				}
				else
				{ 
					yyerror("Unknown automaton variable '" + (string)yyvsp[0].mystring +"'."); delete pcrs; yyval.crs=NULL; 
				}; 
			}
			else 
				yyerror("Don't know which set of states '" + (string)yyvsp[0].mystring +"' refers to."); 
		;}
    break;

  case 67:
#line 1057 "parser.y"
    {
			if (psymb_state!=NULL)
			{
				if (psymb_state->var_names.contains_name((string)yyvsp[0].mystring))
				{
					yyvsp[-2].crs->insert(psymb_state->var_names.get_id((string)yyvsp[0].mystring));
					yyval.crs=yyvsp[-2].crs;
				}
				else
				{ 
					yyerror("Unknown state variable '" + (string)yyvsp[0].mystring +"'."); 
				}; 
			}
			else if (paut!=NULL)
			{
				if (paut->var_id_map.contains_name((string)yyvsp[0].mystring))
				{
					yyvsp[-2].crs->insert(paut->var_id_map.get_id((string)yyvsp[0].mystring));
					yyval.crs=yyvsp[-2].crs;
				}
				else
				{ 
					yyerror("Unknown automaton variable '" + (string)yyvsp[0].mystring +"'."); 
				}; 
			}
			else
				yyerror("Don't know which set of states '" + (string)yyvsp[0].mystring +"' refers to."); 
		;}
    break;

  case 68:
#line 1089 "parser.y"
    {yyval.pident_list->push_back((string)yyvsp[0].mystring);;}
    break;

  case 69:
#line 1090 "parser.y"
    {yyval.pident_list = new list<string>; 
						         yyval.pident_list->push_back((string)yyvsp[-2].mystring);
                           yyval.pident_list->push_back((string)yyvsp[0].mystring); ;}
    break;

  case 70:
#line 1139 "parser.y"
    { linexmap[(string)yyvsp[-3].mystring]=*yyvsp[-1].linexp; delete yyvsp[-1].linexp; ;}
    break;

  case 71:
#line 1140 "parser.y"
    { set_DHR_THRESHOLD_PHAVER(yyvsp[-1].linexp->rat_inhomogeneous_term()); delete yyvsp[-1].linexp; ;}
    break;

  case 72:
#line 1142 "parser.y"
    { ELAPSE_TIME=yyvsp[-1].mybool; ;}
    break;

  case 73:
#line 1143 "parser.y"
    { TIME_POST_ITER=atoi(yyvsp[-1].mystring); ;}
    break;

  case 74:
#line 1144 "parser.y"
    { TIME_POST_CONE_ITER=atoi(yyvsp[-1].mystring); ;}
    break;

  case 75:
#line 1146 "parser.y"
    { TIME_POST_LAMBDA=(yyvsp[-1].linexp->rat_inhomogeneous_term()); delete yyvsp[-1].linexp; ;}
    break;

  case 76:
#line 1147 "parser.y"
    { MEMORY_MODE=atoi(yyvsp[-1].mystring); ;}
    break;

  case 77:
#line 1150 "parser.y"
    { CREATION_GRAPH_OUTPUT=yyvsp[-1].mybool; ;}
    break;

  case 78:
#line 1151 "parser.y"
    { CHEAP_CONTAIN_RETURN_OTHERS=yyvsp[-1].mybool; ;}
    break;

  case 79:
#line 1152 "parser.y"
    { USE_CONVEX_HULL=yyvsp[-1].mybool; ;}
    break;

  case 80:
#line 1153 "parser.y"
    { USE_CONSTRAINT_HULL=yyvsp[-1].mybool; ;}
    break;

  case 81:
#line 1154 "parser.y"
    { REACH_STOP_AT_FORB=yyvsp[-1].mybool; ;}
    break;

  case 82:
#line 1155 "parser.y"
    { REACH_ONLY_EXPLORE=yyvsp[-1].mybool; ;}
    break;

  case 83:
#line 1156 "parser.y"
    { REACH_USE_BBOX=yyvsp[-1].mybool; ;}
    break;

  case 84:
#line 1157 "parser.y"
    { REACH_MAX_ITER=atoi(yyvsp[-1].mystring); ;}
    break;

  case 85:
#line 1158 "parser.y"
    { REACH_MAX_ITER=-atoi(yyvsp[-1].mystring); ;}
    break;

  case 86:
#line 1159 "parser.y"
    { REACH_USE_BBOX_ITER=atoi(yyvsp[-1].mystring); ;}
    break;

  case 87:
#line 1160 "parser.y"
    { REACH_STOP_USE_CONVEX_HULL_ITER=atoi(yyvsp[-1].mystring); ;}
    break;

  case 88:
#line 1161 "parser.y"
    { REACH_STOP_USE_BITSIZE=atoi(yyvsp[-1].mystring); ;}
    break;

  case 89:
#line 1162 "parser.y"
    { REACH_STOP_USE_CONVEX_HULL_SETTLE=yyvsp[-1].mybool; ;}
    break;

  case 90:
#line 1163 "parser.y"
    { BOUND_BOX_BITSIZE=atoi(yyvsp[-1].mystring); ;}
    break;

  case 91:
#line 1164 "parser.y"
    { CONSTRAINT_BITSIZE=atoi(yyvsp[-1].mystring); ;}
    break;

  case 92:
#line 1165 "parser.y"
    { LIMIT_CONSTRAINTS_METHOD=yyvsp[-1].mybool; ;}
    break;

  case 93:
#line 1166 "parser.y"
    { REFINE_DERIVATIVE_METHOD=atoi(yyvsp[-1].mystring); ;}
    break;

  case 94:
#line 1167 "parser.y"
    { REFINE_PRIORITIZE_REACH_SPLIT=yyvsp[-1].mybool; ;}
    break;

  case 95:
#line 1168 "parser.y"
    { REFINE_SMALLEST_FIRST=yyvsp[-1].mybool; ;}
    break;

  case 96:
#line 1169 "parser.y"
    { REFINE_USE_FP=yyvsp[-1].mybool; ;}
    break;

  case 97:
#line 1170 "parser.y"
    { REFINE_DERIV_MINANGLE=yyvsp[-1].linexp->rat_inhomogeneous_term().get_d(); delete yyvsp[-1].linexp; ;}
    break;

  case 98:
#line 1171 "parser.y"
    { REFINE_PRIORITIZE_ANGLE=yyvsp[-1].mybool; ;}
    break;

  case 99:
#line 1172 "parser.y"
    { REACH_CONSTRAINT_LIMIT=atoi(yyvsp[-1].mystring); ;}
    break;

  case 100:
#line 1173 "parser.y"
    { TP_CONSTRAINT_LIMIT=atoi(yyvsp[-1].mystring); ;}
    break;

  case 101:
#line 1174 "parser.y"
    { REACH_CONSTRAINT_TRIGGER=atoi(yyvsp[-1].mystring); ;}
    break;

  case 102:
#line 1175 "parser.y"
    { REACH_BITSIZE_TRIGGER=atoi(yyvsp[-1].mystring); ;}
    break;

  case 103:
#line 1176 "parser.y"
    { SEARCH_METHOD=atoi(yyvsp[-1].mystring); ;}
    break;

  case 104:
#line 1177 "parser.y"
    { SEARCH_METHOD=-atoi(yyvsp[-1].mystring); ;}
    break;

  case 105:
#line 1178 "parser.y"
    { SNAPSHOT_INTERVAL=atoi(yyvsp[-1].mystring); ;}
    break;

  case 106:
#line 1180 "parser.y"
    { REFINE_CHECK_TIME_RELEVANCE=yyvsp[-1].mybool; ;}
    break;

  case 107:
#line 1181 "parser.y"
    { REFINE_CHECK_TIME_RELEVANCE_DURING=yyvsp[-1].mybool; ;}
    break;

  case 108:
#line 1182 "parser.y"
    { REFINE_CHECK_TIME_RELEVANCE_FINAL=yyvsp[-1].mybool; ;}
    break;

  case 109:
#line 1183 "parser.y"
    { REFINE_CHECK_TRANS_DIMS=yyvsp[-1].mybool; ;}
    break;

  case 110:
#line 1184 "parser.y"
    { REFINE_PARTITION_INSIDE=yyvsp[-1].mybool; ;}
    break;

  case 111:
#line 1185 "parser.y"
    { REACH_FB_REFINE_METHOD=atoi(yyvsp[-1].mystring); ;}
    break;

  case 112:
#line 1186 "parser.y"
    { REFINE_INTERSECT_METHOD=atoi(yyvsp[-1].mystring); ;}
    break;

  case 113:
#line 1187 "parser.y"
    { REFINE_LOCATION_PLANE=atoi(yyvsp[-1].mystring); ;}
    break;

  case 114:
#line 1188 "parser.y"
    { REFINE_MAX_CHECKS=atoi(yyvsp[-1].mystring); ;}
    break;

  case 115:
#line 1191 "parser.y"
    { USE_CONVEX_HULL_FOR_PRIMING=yyvsp[-1].mybool; ;}
    break;

  case 116:
#line 1192 "parser.y"
    { PRIME_R_WITH_REACH=yyvsp[-1].mybool; ;}
    break;

  case 117:
#line 1193 "parser.y"
    { PRIME_R_WITH_DISCRETE_REACH=yyvsp[-1].mybool; ;}
    break;

  case 118:
#line 1194 "parser.y"
    { SHOW_BAD_STATES=yyvsp[-1].mybool; ;}
    break;

  case 119:
#line 1195 "parser.y"
    { SIM_SIMPLIFY_R=yyvsp[-1].mybool; ;}
    break;

  case 120:
#line 1197 "parser.y"
    { MINIM_USE_CONVEX_HULL_FOR_PRIMING=yyvsp[-1].mybool; ;}
    break;

  case 121:
#line 1198 "parser.y"
    { MINIM_PRIME_R_WITH_REACH=yyvsp[-1].mybool; ;}
    break;

  case 122:
#line 1200 "parser.y"
    { COMPOSE_WITH_REACH_MIN=yyvsp[-1].mybool; ;}
    break;

  case 123:
#line 1201 "parser.y"
    { COMPOSE_USE_CONVEX_HULL_FOR_REACH=yyvsp[-1].mybool; ;}
    break;

  case 124:
#line 1202 "parser.y"
    { USE_HIOA_AUTOMATA=yyvsp[-1].mybool; ;}
    break;

  case 125:
#line 1206 "parser.y"
    { yyval.mybool=true; ;}
    break;

  case 126:
#line 1207 "parser.y"
    { yyval.mybool=false; ;}
    break;

  case 127:
#line 1211 "parser.y"
    {paut=new automaton(yyvsp[0].mystring); pautmap[yyvsp[0].mystring]=paut; ;}
    break;

  case 128:
#line 1212 "parser.y"
    {
      if (USE_HIOA_AUTOMATA)
         paut->add_environment_transitions();
   ;}
    break;

  case 136:
#line 1234 "parser.y"
    {
         paut->priority=(yyvsp[-1].linexp->rat_inhomogeneous_term().get_int()); delete yyvsp[-1].linexp;
      ;}
    break;

  case 137:
#line 1241 "parser.y"
    {
         if (paut != NULL)
         {
            for (list<string>::const_iterator i=yyvsp[-1].pident_list->begin();i!=yyvsp[-1].pident_list->end();++i)
            {
               paut->add_label(*i);
            }
            delete yyvsp[-1].pident_list;
         }
         else
            yyerror("synclabs: paut not defined");
      ;}
    break;

  case 141:
#line 1267 "parser.y"
    { paut->add_variable((string)yyvsp[0].mystring); ;}
    break;

  case 142:
#line 1268 "parser.y"
    { paut->add_variable((string)yyvsp[0].mystring); ;}
    break;

  case 143:
#line 1271 "parser.y"
    { paut->add_ext_variable((string)yyvsp[0].mystring); ;}
    break;

  case 144:
#line 1272 "parser.y"
    { paut->add_ext_variable((string)yyvsp[0].mystring); ;}
    break;

  case 145:
#line 1275 "parser.y"
    { paut->add_parameter((string)yyvsp[0].mystring); ;}
    break;

  case 146:
#line 1276 "parser.y"
    { paut->add_parameter((string)yyvsp[0].mystring); ;}
    break;

  case 147:
#line 1280 "parser.y"
    {
                           yyval.pident_list->push_back((string)yyvsp[0].mystring);
                           delete yyvsp[0].mystring;
                        ;}
    break;

  case 148:
#line 1285 "parser.y"
    {
                           yyval.pident_list = new list<string>; 
						         yyval.pident_list->push_back((string)yyvsp[0].mystring);
                           delete yyvsp[0].mystring;
                        ;}
    break;

  case 149:
#line 1291 "parser.y"
    {  
                           for (list<string>::const_iterator it=yyvsp[-1].pident_list->begin();it!=yyvsp[-1].pident_list->end();++it)
                           {
                              yyval.pident_list->push_back((string)yyvsp[-3].mystring + *it);
                           }
                           delete yyvsp[-3].mystring;
                           delete yyvsp[-1].pident_list;
                        ;}
    break;

  case 150:
#line 1300 "parser.y"
    {  
                           yyval.pident_list = new list<string>; 
                           for (list<string>::const_iterator it=yyvsp[-1].pident_list->begin();it!=yyvsp[-1].pident_list->end();++it)
                           {
                              yyval.pident_list->push_back((string)yyvsp[-3].mystring + *it);
                           }
                           delete yyvsp[-3].mystring;
                           delete yyvsp[-1].pident_list;
                        ;}
    break;

  case 151:
#line 1314 "parser.y"
    { 
		paut->ini_states_assign(*yyvsp[-1].symb_state); 
  		delete yyvsp[-1].symb_state;;}
    break;

  case 152:
#line 1317 "parser.y"
    { paut->ini_states_assign(*yyvsp[-1].symb_state); delete yyvsp[-1].symb_state; ;}
    break;

  case 153:
#line 1322 "parser.y"
    { 
				if (paut != NULL)
				{
					psymb_state = new symb_states_type(paut->get_var_names());
//   				if (paut->loc_name_to_loc_ref_map.find((string)$1)!=paut->loc_name_to_loc_ref_map.end())
					psymb_state->add((string)yyvsp[-2].mystring,*yyvsp[0].cvs);
					delete yyvsp[0].cvs;
					yyval.symb_state=psymb_state; 
				}
				else
					yyerror("Don't know which automaton to attribute states to.");
		;}
    break;

  case 154:
#line 1335 "parser.y"
    { 
				if (paut != NULL)
				{
					psymb_state->add((string)yyvsp[-2].mystring,*yyvsp[0].cvs);
					delete yyvsp[0].cvs;
					yyval.symb_state=psymb_state; 
				}
				else
					yyerror("Don't know which automaton to attribute states to.");
		;}
    break;

  case 159:
#line 1357 "parser.y"
    { 
			// gf 2006-02-15 : use primed variables as derivatives
//			paut->add_location(*$5,(string)$2,*$8; delete $5; delete $8;
			(*yyvsp[-1].con_list).dimension_move_assign(0,(paut->dim)-1,paut->dim);
			paut->add_location(*yyvsp[-4].cvs,(string)yyvsp[-7].mystring,*yyvsp[-1].con_list); 
			delete yyvsp[-4].cvs; delete yyvsp[-1].con_list;
      	current_loc_name=(string)yyvsp[-7].mystring; // will serve as the source location for the coming transitions
      ;}
    break;

  case 162:
#line 1374 "parser.y"
    { 
			for (list<string>::const_iterator i=yyvsp[-7].pident_list->begin();i!=yyvsp[-7].pident_list->end();++i)
			{
				paut->add_transition(current_loc_name,*i,*yyvsp[-9].cvs,*yyvsp[-4].cvs,(string)yyvsp[-1].mystring); 
			};
			delete yyvsp[-7].pident_list;
		;}
    break;

  case 163:
#line 1382 "parser.y"
    { //paut->add_transition(current_loc_name,(string)$8,*$2,*$5,(string)$10); 
			for (list<string>::const_iterator i=yyvsp[-3].pident_list->begin();i!=yyvsp[-3].pident_list->end();++i)
			{
				paut->add_transition(current_loc_name,*i,*yyvsp[-9].cvs,*yyvsp[-6].cvs,(string)yyvsp[-1].mystring); 
			};
			delete yyvsp[-3].pident_list;			
		;}
    break;

  case 164:
#line 1390 "parser.y"
    { 
				// paut->add_transition(current_loc_name,(string)$4,*$2,clock_ref_set(),(string)$6); // format ...,guard,mudest,... dimensions don't matter
			mycvs=clock_val_set(paut->dim*2);
				// add constraints that controlled variables remain constant
			for (clock_ref_set::const_iterator i=paut->variables.begin();i!=paut->variables.end();++i)
			{ mycvs.add_constraint(Variable(*i)==Variable(*i+paut->dim)); };
			
			for (list<string>::const_iterator i=yyvsp[-3].pident_list->begin();i!=yyvsp[-3].pident_list->end();++i)
			{
				paut->add_transition(current_loc_name,*i,*yyvsp[-5].cvs,mycvs,(string)yyvsp[-1].mystring); 
			};
			delete yyvsp[-3].pident_list;			
		;}
    break;

  case 165:
#line 1404 "parser.y"
    { 
			for (list<string>::const_iterator i=yyvsp[-7].pident_list->begin();i!=yyvsp[-7].pident_list->end();++i)
			{
				trans_ref=paut->add_transition(current_loc_name,*i,*yyvsp[-10].cvs,*yyvsp[-4].cvs,(string)yyvsp[-1].mystring); 
            if (trans_ref<paut->transitions.size())
               paut->transitions[trans_ref].set_urgent();
			};
			delete yyvsp[-7].pident_list;
		;}
    break;

  case 166:
#line 1414 "parser.y"
    { //paut->add_transition(current_loc_name,(string)$8,*$2,*$5,(string)$10); 
			for (list<string>::const_iterator i=yyvsp[-3].pident_list->begin();i!=yyvsp[-3].pident_list->end();++i)
			{
				trans_ref=paut->add_transition(current_loc_name,*i,*yyvsp[-10].cvs,*yyvsp[-6].cvs,(string)yyvsp[-1].mystring); 
            if (trans_ref<paut->transitions.size())
               paut->transitions[trans_ref].set_urgent();
			};
			delete yyvsp[-3].pident_list;			
		;}
    break;

  case 167:
#line 1424 "parser.y"
    { 
				// paut->add_transition(current_loc_name,(string)$4,*$2,clock_ref_set(),(string)$6); // format ...,guard,mudest,... dimensions don't matter
			mycvs=clock_val_set(paut->dim*2);
				// add constraints that controlled variables remain constant
			for (clock_ref_set::const_iterator i=paut->variables.begin();i!=paut->variables.end();++i)
			{ mycvs.add_constraint(Variable(*i)==Variable(*i+paut->dim)); };
			
			for (list<string>::const_iterator i=yyvsp[-3].pident_list->begin();i!=yyvsp[-3].pident_list->end();++i)
			{
				trans_ref=paut->add_transition(current_loc_name,*i,*yyvsp[-6].cvs,mycvs,(string)yyvsp[-1].mystring); 
            if (trans_ref<paut->transitions.size())
               paut->transitions[trans_ref].set_urgent();
			};
			delete yyvsp[-3].pident_list;			
		;}
    break;

  case 168:
#line 1443 "parser.y"
    { yyvsp[-2].pconstraint_rat_pair_list->push_back(*yyvsp[0].pconstraint_rat_pair); delete yyvsp[0].pconstraint_rat_pair;;}
    break;

  case 169:
#line 1445 "parser.y"
    { yyval.pconstraint_rat_pair_list=new list<ConstraintRatPair>; yyval.pconstraint_rat_pair_list->push_back(*yyvsp[0].pconstraint_rat_pair); delete yyvsp[0].pconstraint_rat_pair; ;}
    break;

  case 170:
#line 1450 "parser.y"
    { 
			yyval.pconstraint_rat_pair= new ConstraintRatPair(0*Variable(paut->dim-1)+(Linear_Expression)(*yyvsp[-3].linexp)>=0,make_pair(yyvsp[-1].linexp->rat_inhomogeneous_term()*Rational(yyvsp[-3].linexp->denominator),Rational(0))); 
			delete yyvsp[-3].linexp; 
			delete yyvsp[-1].linexp; 
		;}
    break;

  case 171:
#line 1456 "parser.y"
    { 
			yyval.pconstraint_rat_pair= new ConstraintRatPair(0*Variable(paut->dim-1)+(Linear_Expression)(*yyvsp[-5].linexp)>=0,make_pair(Rational(yyvsp[-5].linexp->denominator)*(yyvsp[-3].linexp->rat_inhomogeneous_term()),Rational(yyvsp[-5].linexp->denominator)*(yyvsp[-1].linexp->rat_inhomogeneous_term()))); 
			delete yyvsp[-5].linexp; 
			delete yyvsp[-3].linexp; 
			delete yyvsp[-1].linexp; 
		;}
    break;

  case 172:
#line 1479 "parser.y"
    {yyvsp[-2].cvs->union_assign(*(yyvsp[0].cvs)); yyval.cvs=yyvsp[-2].cvs; delete yyvsp[0].cvs;;}
    break;

  case 173:
#line 1481 "parser.y"
    {yyvsp[-2].cvs->intersection_assign(*(yyvsp[0].cvs)); yyval.cvs=yyvsp[-2].cvs; delete yyvsp[0].cvs;;}
    break;

  case 174:
#line 1489 "parser.y"
    {yyvsp[0].cvs->negate(); yyval.cvs=yyvsp[0].cvs;;}
    break;

  case 175:
#line 1490 "parser.y"
    {yyval.cvs=yyvsp[-1].cvs;;}
    break;

  case 176:
#line 1492 "parser.y"
    { // cout << "con: " << endl << *$1 << endl << flush;
			pcvs = new clock_val_set(convex_clock_val_set(*yyvsp[0].con_list,yyvsp[0].con_list->space_dimension()));yyval.cvs=pcvs;
			delete yyvsp[0].con_list;
		;}
    break;

  case 177:
#line 1501 "parser.y"
    { yyvsp[-2].con_list->union_assign(*yyvsp[0].con_list); delete yyvsp[0].con_list; yyval.con_list=yyvsp[-2].con_list; ;}
    break;

  case 179:
#line 1507 "parser.y"
    { yyval.con_list = new Constraint_List((dimension_type)(2*paut->dim)); yyval.con_list->push_back(*yyvsp[0].con); delete yyvsp[0].con; ;}
    break;

  case 180:
#line 1508 "parser.y"
    {
         yyval.con_list = new Constraint_List((dimension_type)(2*paut->dim)); 
         yyval.con_list->push_back(Constraint(0*Variable(paut->dim-1)+(yyvsp[-2].linexp->denominator)*(Linear_Expression)(*(yyvsp[-4].linexp))<=(yyvsp[-4].linexp->denominator)*(Linear_Expression)(*(yyvsp[-2].linexp)))); 
         yyval.con_list->push_back(Constraint(0*Variable(paut->dim-1)+(yyvsp[0].linexp->denominator)*(Linear_Expression)(*(yyvsp[-2].linexp))<=(yyvsp[-2].linexp->denominator)*(Linear_Expression)(*(yyvsp[0].linexp)))); 
         delete yyvsp[-4].linexp; 
         delete yyvsp[-2].linexp; 
         delete yyvsp[0].linexp; 
			;}
    break;

  case 181:
#line 1516 "parser.y"
    {
         yyval.con_list = new Constraint_List((dimension_type)(2*paut->dim)); 
         yyval.con_list->push_back(Constraint(0*Variable(paut->dim-1)+(yyvsp[-2].linexp->denominator)*(Linear_Expression)(*(yyvsp[-4].linexp))<(yyvsp[-4].linexp->denominator)*(Linear_Expression)(*(yyvsp[-2].linexp)))); 
         yyval.con_list->push_back(Constraint(0*Variable(paut->dim-1)+(yyvsp[0].linexp->denominator)*(Linear_Expression)(*(yyvsp[-2].linexp))<=(yyvsp[-2].linexp->denominator)*(Linear_Expression)(*(yyvsp[0].linexp)))); 
         delete yyvsp[-4].linexp; 
         delete yyvsp[-2].linexp; 
         delete yyvsp[0].linexp; 
			;}
    break;

  case 182:
#line 1524 "parser.y"
    {
         yyval.con_list = new Constraint_List((dimension_type)(2*paut->dim)); 
         yyval.con_list->push_back(Constraint(0*Variable(paut->dim-1)+(yyvsp[-2].linexp->denominator)*(Linear_Expression)(*(yyvsp[-4].linexp))<=(yyvsp[-4].linexp->denominator)*(Linear_Expression)(*(yyvsp[-2].linexp)))); 
         yyval.con_list->push_back(Constraint(0*Variable(paut->dim-1)+(yyvsp[0].linexp->denominator)*(Linear_Expression)(*(yyvsp[-2].linexp))<(yyvsp[-2].linexp->denominator)*(Linear_Expression)(*(yyvsp[0].linexp)))); 
         delete yyvsp[-4].linexp; 
         delete yyvsp[-2].linexp; 
         delete yyvsp[0].linexp; 
                        ;}
    break;

  case 183:
#line 1532 "parser.y"
    {
         yyval.con_list = new Constraint_List((dimension_type)(2*paut->dim)); 
         yyval.con_list->push_back(Constraint(0*Variable(paut->dim-1)+(yyvsp[-2].linexp->denominator)*(Linear_Expression)(*(yyvsp[-4].linexp))<(yyvsp[-4].linexp->denominator)*(Linear_Expression)(*(yyvsp[-2].linexp)))); 
         yyval.con_list->push_back(Constraint(0*Variable(paut->dim-1)+(yyvsp[0].linexp->denominator)*(Linear_Expression)(*(yyvsp[-2].linexp))<(yyvsp[-2].linexp->denominator)*(Linear_Expression)(*(yyvsp[0].linexp)))); 
         delete yyvsp[-4].linexp; 
         delete yyvsp[-2].linexp; 
         delete yyvsp[0].linexp; 
			;}
    break;

  case 184:
#line 1544 "parser.y"
    {
			pcon= new Constraint(0*Variable(paut->dim-1)+(yyvsp[0].linexp->denominator)*(Linear_Expression)(*(yyvsp[-2].linexp))<(yyvsp[-2].linexp->denominator)*(Linear_Expression)(*(yyvsp[0].linexp))); 
			yyval.con=pcon; delete yyvsp[-2].linexp; delete yyvsp[0].linexp; // cout << endl << *pcon << endl << flush;
			;}
    break;

  case 185:
#line 1548 "parser.y"
    {
			pcon= new Constraint(0*Variable(paut->dim-1)+(yyvsp[0].linexp->denominator)*(Linear_Expression)(*(yyvsp[-2].linexp))>(yyvsp[-2].linexp->denominator)*(Linear_Expression)(*(yyvsp[0].linexp))); 
			yyval.con=pcon; delete yyvsp[-2].linexp; delete yyvsp[0].linexp; // cout << endl << *pcon << endl << flush;
			;}
    break;

  case 186:
#line 1552 "parser.y"
    {
			pcon= new Constraint(0*Variable(paut->dim-1)+(yyvsp[0].linexp->denominator)*(Linear_Expression)(*(yyvsp[-2].linexp))>=(yyvsp[-2].linexp->denominator)*(Linear_Expression)(*(yyvsp[0].linexp))); 
			yyval.con=pcon; delete yyvsp[-2].linexp; delete yyvsp[0].linexp; // cout << endl << *pcon << endl << flush;
			;}
    break;

  case 187:
#line 1556 "parser.y"
    {
			pcon= new Constraint(0*Variable(paut->dim-1)+(yyvsp[0].linexp->denominator)*(Linear_Expression)(*(yyvsp[-2].linexp))<=(yyvsp[-2].linexp->denominator)*(Linear_Expression)(*(yyvsp[0].linexp))); 
			yyval.con=pcon; delete yyvsp[-2].linexp; delete yyvsp[0].linexp; // cout << endl << *pcon << endl << flush;
			;}
    break;

  case 188:
#line 1560 "parser.y"
    {
			pcon= new Constraint(0*Variable(paut->dim-1)+(yyvsp[0].linexp->denominator)*(Linear_Expression)(*(yyvsp[-2].linexp))==(yyvsp[-2].linexp->denominator)*(Linear_Expression)(*(yyvsp[0].linexp))); 
			yyval.con=pcon; delete yyvsp[-2].linexp; delete yyvsp[0].linexp; // cout << endl << *pcon << endl << flush;
			;}
    break;

  case 189:
#line 1565 "parser.y"
    {pcon= new Constraint(0*Variable(paut->dim-1)==0*Variable(paut->dim-1)); yyval.con=pcon;;}
    break;

  case 190:
#line 1567 "parser.y"
    {pcon= new Constraint(0*Variable(paut->dim-1)<=1*Variable(paut->dim-1)); yyval.con=pcon;;}
    break;

  case 191:
#line 1574 "parser.y"
    {
				plinexp = new Rational_Linear_Expression((string)yyvsp[0].mystring);yyval.linexp=plinexp; //cout << "INT: "<< *plinexp << endl;
			;}
    break;

  case 192:
#line 1578 "parser.y"
    { 
			//plinexp = new Rational_Linear_Expression(0*Variable(paut->dim*2-1)+Variable(paut->dim+paut->clock_name_to_clock_ref_map[(string)$1]));
	   	//$$=plinexp; 
			  		if (paut->var_id_map.contains_name((string)yyvsp[-1].mystring))
          		{
            		plinexp = new Rational_Linear_Expression(Linear_Expression(0*Variable(paut->dim*2-1)+Variable(paut->dim+paut->var_id_map.get_id((string)yyvsp[-1].mystring))));
  	   	    		yyval.linexp=plinexp;
          		}
          		else
          		{
            		yyerror("Either variable " + (string)yyvsp[-1].mystring +" not defined in automaton " + paut->name + ", or undefined shortcut.");
          		};
			;}
    break;

  case 193:
#line 1592 "parser.y"
    { 
				if (linexmap.find((string)yyvsp[0].mystring)==linexmap.end())
           	{ 
			  		if (paut!=NULL && paut->var_id_map.contains_name((string)yyvsp[0].mystring))
          		{
            		plinexp = new Rational_Linear_Expression(Linear_Expression(0*Variable(paut->dim-1)+Variable(paut->var_id_map.get_id((string)yyvsp[0].mystring))));
  	   	    		yyval.linexp=plinexp;
          		}
          		else
          		{
                  if (paut!=NULL)
               		yyerror("Either variable " + (string)yyvsp[0].mystring +" not defined in automaton " + paut->name + ", or undefined shortcut.");
                  else
               		yyerror("Can't identify \"" + (string)yyvsp[0].mystring +"\".");
          		};
        		}
        		else
        		{ 
//				  plinexp = new Rational_Linear_Expression(Rational_Linear_Expression(Linear_Expression(0*Variable(paut->dim-1)))+linexmap[(string)$1]);
					plinexp = new Rational_Linear_Expression(linexmap[(string)yyvsp[0].mystring]);
          		yyval.linexp=plinexp;
        		};
      	;}
    break;

  case 194:
#line 1616 "parser.y"
    { if (attempt_multiply(*(yyvsp[-2].linexp),*(yyvsp[0].linexp)))
          { yyval.linexp=yyvsp[-2].linexp; delete yyvsp[0].linexp;}
        else
				{
          yyerror("Can not multiply two linear expressions. ");
					cout << *(yyvsp[-2].linexp) << " and " << *(yyvsp[0].linexp) << endl;
				};
      ;}
    break;

  case 195:
#line 1625 "parser.y"
    { if (attempt_division(*(yyvsp[-2].linexp),*(yyvsp[0].linexp)))
          { yyval.linexp=yyvsp[-2].linexp; delete yyvsp[0].linexp;}
        else
          yyerror("Can not divide two linear expressions.");
      ;}
    break;

  case 196:
#line 1630 "parser.y"
    {plinexp = new Rational_Linear_Expression((*(yyvsp[-2].linexp))+(*(yyvsp[0].linexp)));yyval.linexp=plinexp; //cout << "l+l:(" << *$1 << ")-(" << *$3 << ")=" << *plinexp << endl;
 delete yyvsp[-2].linexp; delete yyvsp[0].linexp;;}
    break;

  case 197:
#line 1632 "parser.y"
    {plinexp = new Rational_Linear_Expression((*(yyvsp[-2].linexp))-(*(yyvsp[0].linexp)));yyval.linexp=plinexp; //cout << "l-l:(" << *$1 << ")-(" << *$3 << ")=" << *plinexp << endl;
 delete yyvsp[-2].linexp; delete yyvsp[0].linexp;;}
    break;

  case 198:
#line 1635 "parser.y"
    { 
				// plinexp = new Rational_Linear_Expression(Rational_Linear_Expression(Integer(0))-(*($2)));$$=plinexp; delete $2;}
				yyvsp[0].linexp->Linear_Expression::operator=(-(Linear_Expression)*yyvsp[0].linexp); yyval.linexp=yyvsp[0].linexp; //cout << "-l: " << *$$ << endl;
			;}
    break;

  case 199:
#line 1640 "parser.y"
    {
				yyval.linexp=yyvsp[-1].linexp; 
				// cout << endl << *$2 << endl;
			;}
    break;


    }

/* Line 1010 of yacc.c.  */
#line 3714 "parser.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {
		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
		 yydestruct (yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
	  yydestruct (yytoken, &yylval);
	  yychar = YYEMPTY;

	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 1646 "parser.y"



